#!/bin/bash

#install ruby
sudo apt-get install -y ruby-full build-essential rubygems1.8

#juicer dependency
sudo apt-get install libxml2 libxml2-dev libxslt1-dev

# Gems
required_gems="juicer"

# Install Ruby Gems manually
if ! which gem >/dev/null; then
    wget http://rubyforge.org/frs/download.php/60718/rubygems-1.3.5.tgz
    tar xvfz rubygems-1.3.5.tgz
    ruby rubygems-1.3.5/setup.rb
    ln -s /usr/bin/gem1.8 /usr/bin/gem
    gem update --system
    rm -rf rubygems-1.3.5.tgz rubygems-1.3.5
fi

# Install required gems
for required_gem in ${required_gems}
do
    if ! gem list | grep $required_gem >/dev/null; then
	gem install $required_gem
    fi
done

sudo ln -s /usr/bin/gem1.8 /usr/local/bin/gem
sudo ln -s /usr/bin/ruby1.8 /usr/local/bin/ruby
sudo ln -s /usr/bin/rdoc1.8 /usr/local/bin/rdoc
sudo ln -s /usr/bin/ri1.8 /usr/local/bin/ri
sudo ln -s /usr/bin/irb1.8 /usr/local/bin/irb 

juicer install yui_compressor
juicer install jslint

echo "Merge JavaScript..."
juicer merge -s -f -t js -c none juicer_bubble -o gtk_bubble_popup_min.js
echo "Merge JavaScript done!!!"

echo "Merge CSS..."
cd src/css
juicer merge -f -e none -c none gtk_bubble_popup.css -o gtk_bubble_popup_min.css
cp -f gtk_bubble_popup_min.css ../../gtk_bubble_popup_min.css
echo "Merge CSS done!!!"

echo "Done!"
