#!/bin/bash

#install ruby
sudo apt-get install -y ruby-full build-essential rubygems1.8

#juicer dependency
sudo apt-get install libxml2 libxml2-dev libxslt1-dev

#Java Runtime Environment (jre)
#sudo apt-get install sun-java6-jdk sun-java6-jre
#sudo apt-get install sun-java6-jre

# Gems
required_gems="juicer"

# Install Ruby Gems manually
if ! which gem >/dev/null; then
    wget http://rubyforge.org/frs/download.php/60718/rubygems-1.3.5.tgz
    tar xvfz rubygems-1.3.5.tgz
    sudo ruby rubygems-1.3.5/setup.rb
    ln -s /usr/bin/gem1.8 /usr/bin/gem
    sudo gem update --system
    rm -rf rubygems-1.3.5.tgz rubygems-1.3.5
fi

echo ""
echo ""
echo "--------------------------------------"
# Install required gems
for required_gem in ${required_gems}
do
    if ! gem list | grep $required_gem >/dev/null; then
    echo "Require installing gem"
    echo "Downloading and installing gem..."
	sudo gem install $required_gem
    fi
done

sudo ln -s /usr/bin/gem1.8 /usr/local/bin/gem
sudo ln -s /usr/bin/ruby1.8 /usr/local/bin/ruby
sudo ln -s /usr/bin/rdoc1.8 /usr/local/bin/rdoc
sudo ln -s /usr/bin/ri1.8 /usr/local/bin/ri
sudo ln -s /usr/bin/irb1.8 /usr/local/bin/irb 
echo "Installation completed!"
echo ""

echo ""
echo "--------------------------------------"
echo "Installing YUI compressor..."
juicer install yui_compressor
echo "Installation completed!"
echo ""

echo ""
echo "--------------------------------------"
echo "Installing JSLint..."
juicer install jslint
echo "Installation completed!"
echo ""

echo "--------------------------------------"
echo "Merging JavaScript files..."
juicer merge -s -f -t js -c none juicer -o jsgtk_min_0.1.4.js
echo "Merging completed!"
echo ""

echo ""
echo "--------------------------------------"
echo "Merging CSS files..."
cd src/css
juicer merge -f -e none -c none gtk_main.css -o jsgtk_min_0.1.4.css
cp -f jsgtk_min_0.1.4.css ../../jsgtk_min_0.1.4.css
echo "Merging completed!"
echo ""

echo ""
echo ""
echo "--------------------------------------"
echo "--------------------------------------"
echo "********** Merging completed! *********"
echo "--------------------------------------"
echo "--------------------------------------"
