mylabs.Shape = function(type,left, top, width, height, tailSide, tailDistance){
    this._posX = left;
    this._posY = top;
    this.paper = type == "popup"? this._renderPopup(width, height) : this._renderBubble(width, height, tailSide, tailDistance);
    return this.paper;
};

mylabs.Shape.prototype = {
    _renderBubble: function(width, height, tailSide, tailDistance){
	    var round;
	    tailDistance = tailDistance||35;
	
	    var tailWidth, tailHeight;
	
	    if(height < 30){
	        tailWidth = 10;
	        tailHeight = 8;
	        round = 5;
	    }
	    else if(height < 70){
	        tailWidth = 10;
	        tailHeight = 10;
	        round = 7;
	    }
	    else{
	        tailWidth = 20;
	        tailHeight = 20;
	        round = 10;
	    }

	    var borderColor = "#B4BED4";
	    var borderWidth = 1;
	    var bgColor = "#FFFFFF"; 
        width += 1;
	    var paper = new MylabsSvgVml(this._posX, this._posY,width + 50,height + 25);

	    var pathString, topLeftCorner, topRightCorner, bottomRightCorner, bottomLeftCorner;
	    if(tailSide == "left"){
	        var widthIncludeTail = width +tailWidth;
            topLeftCorner = "C " + tailWidth + " " + round + " " + tailWidth + " 1 " + (tailWidth + round) + " 1";
            topRightCorner = "C " + (widthIncludeTail - round) + " 1 " + widthIncludeTail + " 1 " + widthIncludeTail + " " + round;
            bottomRightCorner = "C " + widthIncludeTail + " " + (height - round) + " " + widthIncludeTail + " " + height + " " + (widthIncludeTail-round) + " " + height;
            bottomLeftCorner = "C " + (tailWidth + round) + " " + (height) + " " + tailWidth + " " + height + " " + tailWidth + " " + (height - round);

            pathString = "M "+ tailWidth + " "+ round +" " + topLeftCorner + " L "+ (widthIncludeTail - round) + " 1 " + topRightCorner + " L " + widthIncludeTail + " " + (height-round) + " " + bottomRightCorner + " L " + (tailWidth + round) +" "+ height + " " + bottomLeftCorner + " L " + tailWidth + " "+ (tailDistance + tailHeight) + " 1 " + (tailDistance +(tailHeight/2)) + " " + tailWidth +" "+ tailDistance;
	    }
	    else if(tailSide == "right"){            
            topLeftCorner = "C 1 " + round + " 1 1 " + round + " 1";
            topRightCorner = "C " + (width - round) + " 1 " + width + " 1 " + width + " " + round;
            bottomRightCorner = "C " + width + " " + (height-round) + " " + width + " " + height + " " + (width - round) + " " + height;
            bottomLeftCorner = "C " + round + " " + height + " 1 " + height + " 1 " +(height - round);
            
            pathString = "M 1 " + round + " " + topLeftCorner + " L " + (width - round) + " 1 " + topRightCorner + " L " + width + " " + tailDistance + " " + (width + tailHeight) + " " + (tailDistance + (tailHeight/2)) + " " + width + " " + (tailDistance + tailHeight) + " " + width + " " + (height-round) + " " + bottomRightCorner + " L " + round + " " + height + " " + bottomLeftCorner;
	    }
        else if(tailSide == "up"){
            topLeftCorner = "C 1 " + (round + tailHeight) + " 1 "+ tailHeight + " " + round + " " + tailHeight;
            topRightCorner = "C " + (width - round) + " " + tailHeight + " " + width + " " + tailHeight + " " + width + " " + (tailHeight + round);
            bottomRightCorner = "C " + width + " " + (tailHeight + height - round) + " " + width + " " + (tailHeight +height) + " " + (width - round) + " " + (tailHeight + height);
            bottomLeftCorner = "C " + round + " " + (height + tailHeight) + " 1 " + (height + tailHeight) + " 1 " + (tailHeight + height - 8);
        
            pathString = "M 1 " + (round + tailHeight) + " " + topLeftCorner + " L " + tailDistance + " " + tailHeight + " " + (tailDistance + (tailWidth/2)) + " 1 " + (tailDistance + tailHeight) + " " + tailHeight  + " " + (width - round) + " " + tailHeight + " "+ topRightCorner + " L " + width + " " + (tailHeight + height - round) + " " + bottomRightCorner + " L " + round + " " + (height + tailHeight) + " " + bottomLeftCorner;
        }	    
	    else{
	        topLeftCorner = "C 1 " + round + " 1 1 " + round + " 1";
            topRightCorner = "C " + (width - round) + " 1 " + width + " 1 " + width + " " + round;
            bottomRightCorner = "C " + width + " " + (height - round) + " " + width + " " + height + " " + (width - round) + " " + height;
            bottomLeftCorner = "C " + round + " " + height + " " + " 1 " + height + " 1 " + (height -round);
            
            pathString = "M 1 " + round + " " + topLeftCorner + " L " + (width - round) + " 1 " + topRightCorner + " L " + width + " " + (height - round) + " " + bottomRightCorner + " L " + (tailDistance + tailWidth) + " " + height + " " + (tailDistance + (tailWidth/2)) + " "+ (height + tailHeight) +" " + tailDistance + " " + height + " " + round + " " + height + " " + bottomLeftCorner + " L 1 " + round;
	    }
	    
	    pathString += MylabsSvgVml.type == "SVG"? " Z": " x e";

	    var path = paper.path(pathString);
	    path.attr("fill", bgColor);
	    path.attr("stroke", borderColor);
	    path.attr("stroke-width", borderWidth);
	
	    var paperStyle = paper.getNode().style;
	    paperStyle.zIndex = 9000;
	    paperStyle.position = "absolute";
	    paperStyle.left = "0px";
	
	    return paper;
    },
    
    _renderPopup: function(width, height){
        var round = 5;
        var borderWidth = 1;
        var borderColor = "#FFFFFF";
	    var bgColor = "#FFFFFF"; 
        var paper = new MylabsSvgVml(this._posX, this._posY,width,height);      
        var rectangle = paper.rect(round);
        
        rectangle.attr("fill", bgColor);
	    rectangle.attr("stroke", borderColor);
	    rectangle.attr("stroke-width", borderWidth);
	
	    var paperStyle = paper.getNode().style;
	    paperStyle.zIndex = 8001;
	    paperStyle.position = "absolute";
	    paperStyle.left = "0px";
	
	    return paper;
    }
};
