jsgtk.Util = {
    clone: function(obj){
        var Clone = function(){};
        Clone.prototype = obj;
        
        var c = new Clone();
        c.constructor = Clone;
        return c;
    },
	isMatched: function(target, text){
		return new RegExp(target).test(text);
	},
    arrayRemoveElement: function(array, element){
		var isFound = false;
		for(var i = 0, len = array.length; i < len; i++){
			if(array[i] === element){
				isFound = true;
				break;
			} 
		}
		if(isFound) array.splice(i, 1);
	},
    arraySwapElements: function(array, element1, element2){
        var index1 = array.indexOf(element1);
        var index2 = array.indexOf(element2);
        
        array[index1] = null;
        array[index2] = null;

        array[index1] = element2;
        array[index2] = element1;
    },
    windowHeight: function(){
		console.log("depricated, use getWindowHeight()");
    },
    windowWidth: function(){
		console.log("depricated, use getWindowWidth()");
    },
    getWindowHeight: function(){
		var de = document.documentElement;
        return self.innerHeight || ( de && de.clientHeight ) || document.body.clientHeight;
    },
    getWindowWidth: function(){
        var de = document.documentElement;
        return self.innerWidth || ( de && de.clientWidth ) || document.body.clientWidth;
    },
    calculateTextWidthHeight: function(text){ 
        var span = jsgtk.Dom.create({"append": document.body, "tag": "span", "style" : "position:absolute;"});
	    var text = jsgtk.Dom.create({"append": span, "tag": "text", "text": text});
	    var width = span.clientWidth;
	    var height = span.clientHeight;
	    document.body.removeChild(span);
	    return [width, height];    
    },
    getTextFromTop : function(parentHeight, childHeight){
        console.log("depricated")
    },
    
    trim : function(str){
        return str.replace(/^\s+|\s+$/, '');
    },
    
    fullHeight: function(elem) {
        var height;
        document.body.appendChild(elem);
        if ( this.getStyle( elem, 'display' ) != 'none' ){
            height = elem.offsetHeight || this.getHeight(elem);
            document.body.removeChild(elem);
            return height;
        }
        var old = this.resetCSS(elem, {
                display: '',
                visibility: 'hidden',
                position: 'absolute'
            });
        height = elem.clientHeight || this.getHeight(elem);
        this.restoreCSS(elem, old);
        document.body.removeChild(elem);
  
        return height;
    },

    fullWidth: function(elem) {
        var width;

        document.body.appendChild(elem);
        if (this.getStyle(elem, 'display') != 'none' ){
            width = elem.offsetWidth || this.getWidth( elem );
            document.body.removeChild(elem);
            
            return width + jsgtk.Util.EXTRAPIXEL;
        }
        var old = this.resetCSS( elem, {
            display: '',
            visibility: 'hidden',
            position: 'absolute'
        });

        width = elem.clientWidth || this.getWidth( elem );
        this.restoreCSS( elem, old );
        document.body.removeChild(elem);

        return width + jsgtk.Util.EXTRAPIXEL;
    },

    getStyle: function(elem, name){
        if (elem.style[name])
            return elem.style[name];
        else if (elem.currentStyle)
            return elem.currentStyle[name];
        else if (document.defaultView && document.defaultView.getComputedStyle) {
            name = name.replace(/([A-Z])/g,"-$1");
            name = name.toLowerCase();
            var s = document.defaultView.getComputedStyle(elem,"");
            return s && s.getPropertyValue(name);
        } else
            return null;
    },

    getHeight: function(elem) {
        return parseInt( this.getStyle( elem, 'height' ) );
    },

    getWidth: function(elem){
        return parseInt( this.getStyle( elem, 'width' ) );
    },
 	
	pageX: function(elem) {
        return elem.offsetParent ? elem.offsetLeft + this.pageX(elem.offsetParent) : elem.offsetLeft;
    },

    pageY: function(elem) {
        return elem.offsetParent ? elem.offsetTop + this.pageY(elem.offsetParent) : elem.offsetTop;
    },
    
    getPageSize: function() {
        var x, y, b = document.body, wi = window.innerHeight, ws = window.scrollMaxY;
        if (wi && ws) {
            x = b.scrollWidth;
            y = wi + ws;
        } else if (b.scrollHeight > b.offsetHeight) {
            x = b.scrollWidth;
            y = b.scrollHeight;
        } else {
            x = b.offsetWidth;
            y = b.offsetHeight;
        }
        var w, h, d = document.documentElement;
        if (self.innerHeight) {
            w = self.innerWidth;
            h = self.innerHeight;
        } else if (d && d.clientHeight) {
            w = d.clientWidth;
            h = d.clientHeight;
        } else if (b) {
            w = b.clientWidth;
            h = b.clientHeight;
        }
        var pH = (y < h) ? h : y, pW = (x < w) ? w : x;
        
        return [pW, pH, w, h];
    },

    resetCSS: function(elem, prop) {
        var old = {};
        for ( var i in prop ) {
            old[i] = elem.style[i];
            elem.style[i] = prop[i];
        }
        return old;
    },

    restoreCSS: function(elem, prop) {
        for ( var i in prop )
            elem.style[i] = prop[i];
    },
    
    debug: function(msg){
        throw(msg);   
    },
    
    removeArrayElements: function(array, from, to){
        Array.remove(array, from, to);
    },
    
    getScrollX: function() {
        var de = document.documentElement;
        return pageXOffset ||( de && de.scrollLeft ) || document.body.scrollLeft;
    },
    
    getScrollY: function() {
        var de = document.documentElement;
        return self.pageYOffset ||( de && de.scrollTop ) || document.body.scrollTop;
    },
    
    detect: {
	    init: function () {
		    this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		    this.version = this.searchVersion(navigator.userAgent)
			    || this.searchVersion(navigator.appVersion)
			    || "An unknown version";
		    this.OS = this.searchString(this.dataOS) || "An unknown OS";
	    },
	    searchString: function (data) {
		    for (var i=0;i<data.length;i++)	{
			    var dataString = data[i].string;
			    var dataProp = data[i].prop;
			    this.versionSearchString = data[i].versionSearch || data[i].identity;
			    if (dataString) {
				    if (dataString.indexOf(data[i].subString) != -1)
					    return data[i].identity;
			    }
			    else if (dataProp)
				    return data[i].identity;
		    }
	    },
	    searchVersion: function (dataString) {
		    var index = dataString.indexOf(this.versionSearchString);
		    if (index == -1) return;
		    return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	    },
	    dataBrowser: [
		    {
			    string: navigator.userAgent,
			    subString: "Chrome",
			    identity: "Chrome"
		    },
		    { 	string: navigator.userAgent,
			    subString: "OmniWeb",
			    versionSearch: "OmniWeb/",
			    identity: "OmniWeb"
		    },
		    {
			    string: navigator.vendor,
			    subString: "Apple",
			    identity: "Safari",
			    versionSearch: "Version"
		    },
		    {
			    prop: window.opera,
			    identity: "Opera"
		    },
		    {
			    string: navigator.vendor,
			    subString: "iCab",
			    identity: "iCab"
		    },
		    {
			    string: navigator.vendor,
			    subString: "KDE",
			    identity: "Konqueror"
		    },
		    {
			    string: navigator.userAgent,
			    subString: "Firefox",
			    identity: "Firefox"
		    },
		    {
			    string: navigator.vendor,
			    subString: "Camino",
			    identity: "Camino"
		    },
		    {		// for newer Netscapes (6+)
			    string: navigator.userAgent,
			    subString: "Netscape",
			    identity: "Netscape"
		    },
		    {
			    string: navigator.userAgent,
			    subString: "MSIE",
			    identity: "Explorer",
			    versionSearch: "MSIE"
		    },
		    {
			    string: navigator.userAgent,
			    subString: "Gecko",
			    identity: "Mozilla",
			    versionSearch: "rv"
		    },
		    { 		// for older Netscapes (4-)
			    string: navigator.userAgent,
			    subString: "Mozilla",
			    identity: "Netscape",
			    versionSearch: "Mozilla"
		    }
	    ],
	    dataOS : [
		    {
			    string: navigator.platform,
			    subString: "Win",
			    identity: "Windows"
		    },
		    {
			    string: navigator.platform,
			    subString: "Mac",
			    identity: "Mac"
		    },
		    {
			       string: navigator.userAgent,
			       subString: "iPhone",
			       identity: "iPhone/iPod"
	        },
		    {
			    string: navigator.platform,
			    subString: "Linux",
			    identity: "Linux"
		    }
	    ]

    }
};

jsgtk.Util.detect.init();

jsgtk.Util.EXTRAPIXEL = (jsgtk.Util.detect.OS == "Mac" && jsgtk.Util.detect.browser == "Firefox") ? 1 : 0;

// Array Remove - By John Resig (MIT Licensed)
Array.remove = function(array, from, to) {
    var rest = array.slice((to || from) + 1 || array.length);
    array.length = from < 0 ? array.length + from : from;
    return array.push.apply(array, rest);
};
