describe('gobject', {
	'before_each': function(){
		g = {};
		g.gobject = gobject;
		g.gobject._signals = [];
		g.gobject._signalCount = 0;
	},
	'after_each': function(){
		g = null;
	},
	'signalNew() should add a new signal and return an uniqe integer id': function() {
	    var id = g.gobject.signalNew("test", function(){});
	    value_of(id).should_be(1);
	},
	'signalLookup() should return a signalId of object which has been bind to the signal': function() {
		g.type = function(){};
		g.id = g.gobject.signalNew("foo", g.type);
		g.signalId = g.gobject.signalLookup('foo', g.type);
		value_of(g.signalId).should_be(g.id);
	},
	'signalLookup() should return null for the object which has not been bind to the signal': function() {
		g.type = function(){};
		g.id = g.gobject.signalNew("foo", g.type);
		g.signalId = g.gobject.signalLookup('bar', g.type);
		value_of(g.signalId).should_be_null();
	},
	'signalNew() should throw an exception if the signal already exists': function() {
		g.object = function(){};
		g.gobject.signalNew("testing", g.object);
		value_of(	function(){
			g.gobject.signalNew("testing", g.object);
		}).should_throw();
	}
});



