describe('gobject.GObject', {
	'before_each': function(){
		g = {};
		g.gobject = new gobject.GObject();
		
		g.gobjectMock = mock(gobject);
		when( g.gobjectMock.signalLookup("testsignal", "{any object}" ) ).thenReturn(1);
		when( g.gobjectMock.signalLookup("undefinedsignal", "{any object}" ) ).thenReturn(null);
		anyInstance("gobject", g.gobjectMock);
	},
	'after_each': function(){
		g = {};
		verify();
	},
	'connect() should return a handler_id': function(){
	    value_of( typeof g.gobject.connect("testsignal", function(){})).should_be("string");
	    value_of( verify( g.gobjectMock.signalLookup("testsignal", "{any object}") ).called("{at least once}") ).should_be_true();
	},
	'connect() should throw an exception when has yet created': function(){
    	value_of(	function(){
			g.gobject.connect("undefinedsignal", function(){})
		}).should_throw();
		
	    value_of( verify( g.gobjectMock.signalLookup("undefinedsignal", "{any object}") ).called("{at least once}") ).should_be_true();
	},
	'emit() should trigger the connected signal': function(){
        g.gobject.connect("testsignal", function(value){
            value_of(value).should_be_true();
        });
        g.gobject.emit('testsignal', true);
	},
	'disconnect() should remove the connected signal': function(){
        var signalId = g.gobject.connect("testsignal", function(){
            value_of("signal is triggered").should_be(false);
        });
        
        g.gobject.disconnect(signalId);
        g.gobject.emit('testsignal');
	}
});
