describe("gtk.ComboStore", {
	"before_each": function(){
		g = {};
		g.combo = new gtk.ComboStore();
		g.combo.children = [];
		
		g.iterMock = mock(gtk.TreeIter);
		g.iterMock.value = [];
		when(g.iterMock.getPath()).thenReturn("0:");
		when(g.iterMock.getValue()).thenReturn({"display": 'Pop Music'});
		
	    g.iterMock.setRow = function(){};
		anyInstance("gtk.TreeIter", g.iterMock);
	},
	"after_each": function(){
		g = {};
		verify();
	},
	"append(), should return a treeIter object" : function(){
	    g.treeIter = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
	    value_of(g.treeIter).should_be(g.iterMock);
	},
	"append(), should add treeIter Object to g.combo.children" : function(){
        g.treeIter = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
        value_of(g.combo.children[0].uuid).should_be(g.treeIter.uuid)
	},
	"append(), should add treeIter and the treeIter belong to its sibbling group": function(){
    	g.treeIter = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
    	g.treeIter1 = g.combo.append(g.treeIter, {"display": 'Pop Music', "id": 1, "index": 1});
        value_of(g.treeIter1.uuid).should_be(g.treeIter.uuid);
	},
	"getChild(), should return child":function(){
	    g.child1 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
    	g.child2 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 2});
    	value_of(g.combo.getChild(1).uuid).should_be(g.child2.uuid);
	},
	"getChild(), should return child":function(){
    	value_of(g.combo.getChild(2)).should_be_null;
	},
	"getChildren(), should return all children": function(){
	    g.child1 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
    	g.child2 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 2});
    	value_of(g.combo.getChildren().length).should_be(2);
	},
	"remove(), should remove child": function(){
	    g.child1 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
    	g.child2 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 2});
    	g.combo.remove(g.combo.children[0]);
    	value_of(g.combo.children[1]).should_be(undefined);
	},
	"getChildByPath(), should return child":function(){
	    g.child1 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
    	g.child2 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 2});
    	value_of(g.combo.getChildByPath("0:")).should_be(g.child1);
	},
	"search(), should return child path if found":function(){
	    g.child1 = g.combo.append(null, {"display": 'Pop Music', "id": 1, "index": 1});
    	g.foundChild = g.combo.search("Pop Music");
        value_of(g.foundChild).should_be("0:");
	}
	
});
