describe('gtk.Container', {
	'before_each': function(){
		g = {};
		
		g.widgetMock = mock(gtk.Widget);
		g.widgetMock.emit = function(){};
		g.widgetMock._domObj = Dom.create({tag: 'div'});
		anyInstance("gtk.Widget", g.widgetMock);
		
		g.container = new gtk.Container();
	},
	'after_each': function(){
		g = {};
		verify();
	},
	'add() should update the child property to the passed value': function() {
			var widget = {type: "widget"};
			g.container.add(widget);
			value_of( g.container.child ).should_be( widget );
	},
	'add() should do nothing if the child property is already set': function() {
			var widget = {type: "widget"};
			g.container.add(widget);
			g.container.add({});
			value_of( g.container.child ).should_be( widget );			 
	},
	'remove() should should set the child property back to null': function() {
			var widget = {type: "widget"};
			g.container.add(widget);	
			g.container.remove(widget);
			value_of( g.container.child ).should_be_null( );
	},
	'remove() should do nothing if the widget passed is not the same widget referenced by the child property': function() {
			var widget = {type: "widget"};
			g.container.add(widget);	
			g.container.remove({});
			value_of( g.container.child ).should_be( widget );
	},
	'set/getBorderWidth() should update the borderWidth property': function() {
			g.container.setBorderWidth(10);
			value_of(g.container.getBorderWidth()).should_be(10);
	},
	/******************** PRIVATE METHODS ***********************/
	'_resizeContainer, this._minWidth, and this._minHeight, will chaned the value': function(){
		g.container._resizeContainer(100, 100);
		value_of(g.container._minWidth).should_be(100);
		value_of(g.container._minHeight).should_be(100);
		value_of(g.container._domObj.style.width).should_be('100px');
		value_of(g.container._domObj.style.height).should_be("100px");
	}
});
