describe("gtk.hbox",{
	
	"before_each": function() {
		g = {};
		g.box = mock(gtk.Box);
		g.box.connect = function(){};
		g.box.emit = function(){};
			
		anyInstance("gtk.Box", g.box);
		
		//contain for hbox, must have width and height in pixel
		g.parentNode = Dom.create({"tag": "div", "style": "width:400px; height: 200px;"});
		
		//Child dom to pass to hbox
		g.dom = Dom.create({"tag": "div", "style": "minHeight: 100px;"});
		g.dom.style.minWidth = "50px";
		g.child = {_domObj: g.dom};
		
		//hbox
		g.hbox = new gtk.HBox(false, 5);
		
		g.parentNode.appendChild(g.hbox._domObj);
	},
	"after_each": function(){
		g = {};
		verify();
	},
	"when I call packStart() passing a child as an argument, then I will get child's information calling queryChildPacking()" : 
	function() {
		g.hbox.packStart(g.child, true, true, 10);
		var child_info = g.hbox.queryChildPacking(g.child);
		value_of(child_info.expand).should_be(true);
		value_of(child_info.fill).should_be(true);
		value_of(child_info.padding).should_be(10);
		value_of(child_info.packType).should_be(gtk.PACK_START);
	},
	"when I call packEnd() passing a child as an argument, then I will get child's information calling queryChildPacking()" : 
	function() {
		g.hbox.packEnd(g.child, false, false, 10);
		var child_info = g.hbox.queryChildPacking(g.child);
		value_of(child_info.expand).should_be(false);
		value_of(child_info.fill).should_be(false);
		value_of(child_info.padding).should_be(10);
		value_of(child_info.packType).should_be(gtk.PACK_END);
	},
	"when I call packStartDefaults() passing a child as an argument, then I will get child's information calling queryChildPacking()" : 
	function() {
		g.hbox.packStartDefaults(g.child);
		var child_info = g.hbox.queryChildPacking(g.child);
		value_of(child_info.expand).should_be(true);
		value_of(child_info.fill).should_be(true);
		value_of(child_info.padding).should_be(0);
		value_of(child_info.packType).should_be(gtk.PACK_START);
	},
	"when I call packEndDefaults() passing a child as an argument, then I will get child's information calling queryChildPacking()" : 
	function() {
		g.hbox.packEndDefaults(g.child);
		var child_info = g.hbox.queryChildPacking(g.child);
		value_of(child_info.expand).should_be(true);
		value_of(child_info.fill).should_be(true);
		value_of(child_info.padding).should_be(0);
		value_of(child_info.packType).should_be(gtk.PACK_END);
	},
	"when I call setHomogeneous() passing Homogeneous as an argument, then I will get child's information calling getHomogeneous()" : 
	function() {
		g.hbox.packStartDefaults(g.child);
		
		g.hbox.setHomogeneous(true);
		var box_info = g.hbox.getHomogeneous();
		value_of(box_info).should_be(true);
		
		g.hbox.setHomogeneous(false);
		box_info = g.hbox.getHomogeneous();
		value_of(box_info).should_be(false);
	},
	"when I call setSpace() passing 10px as an argument, then I will get child's information calling getSpace()" : function() {
		g.hbox.packStartDefaults(g.child);
		g.hbox.packEndDefaults(g.child);
		g.hbox.setSpace(10);
		var box_info = g.hbox.getSpace();
		value_of(box_info).should_be('10');
	},
	"when I call reOrderChild() passing a child and a position as arguments, then the child in the array will reordered" : function() {
		g.child1 = g.child;
		g.child2 = g.child;
		g.child3 = g.child;
		g.child4 = g.child;
		g.hbox.packStart(g.child1, true, true, 10);
		g.hbox.packStart(g.child2, true, true, 10);
		g.hbox.packEnd(g.child3, true, true, 10);
		g.hbox.packEnd(g.child4, true, true, 10);
		value_of(true).should_be(false)
	}
});
