describe("gtk.HPaned", {
	"before_each": function(){
		g = {};

		//mock image
		g.image = mock(gtk.Image);
		g.image.show = function(){};
		g.image._domObj = Dom.create({tag: 'div'});
		anyInstance("gtk.Image", g.image);
		g.value = 0;
		
		//mock paned
		g.paned = mock(gtk.Paned);
		when( g.paned.getChild1() ).thenReturn(g.image._domObj);
		when( g.paned.getChild2() ).thenReturn(g.image._domObj);
		g.paned.setPosition = function(){g.value = 10;};
		when( g.paned.getPosition()).thenReturn(10);
		anyInstance("gtk.Paned", g.paned);
		g.paned._domObj = Dom.create({tag: 'div'});
		g.paned.show = function(){};
		g.hpaned =  new gtk.HPaned();
	},
	"after_each": function(){
		g = {};
		verify();
	},
	"when I call gtk.HPaned.add1(widget), I will get widget from gtk.HPaned.getChild1()": function(){
		g.hpaned.add1(g.image);
		g.hpaned.show();
		value_of(g.hpaned.getChild1()).should_be(g.image._domObj);
	},
	"when I call gtk.HPaned.add2(widget), I will get widget from gtk.HPaned.getChild2()": function(){
		g.hpaned.add2(g.image);
		g.hpaned.show();
		value_of(g.hpaned.getChild2()).should_be(g.image._domObj);
	},
	"when I call gtk.HPaned.pack1(widget), I will get widget from gtk.HPaned.getChild1()": function(){
		g.hpaned.pack1(g.image);
		g.hpaned.show();
		value_of(g.hpaned.getChild1()).should_be(g.image._domObj);
	},
	"when I call gtk.HPaned.pack2(widget), I will get widget from gtk.HPaned.getChild2()": function(){
		g.hpaned.pack2(g.image);
		g.hpaned.show();
		value_of(g.hpaned.getChild2()).should_be(g.image._domObj);
	},
	"when I call gtk.HPaned.setPosition(g.value), I will get g.value from gtk.HPaned.getPosition()": function(){
		g.hpaned.pack2(g.image);
		g.hpaned.show();
		g.hpaned.setPosition(g.value)
		value_of(g.hpaned.getPosition()).should_be(g.value);
	}
});
