describe("gtk.Label", {
	"before_each": function(){
		g = {};
		g.label = new gtk.Label("default label");
	},
	"after_each": function(){
		g = {};
	},
	"'click' signal": function(){
		g.isEmitted = false;
	
		g.label.connect("clicked", function(){
			g.isEmitted = true;
		});
	
		var clickEvent = document.createEvent ("Event");
		clickEvent.initEvent ("click", true, false);
		g.label.getNode().dispatchEvent (clickEvent);
		
		value_of(g.isEmitted).should_be_true();
	},
	"'mouseover' signal": function(){
		g.isEmitted = false;
	
		g.label.connect("mouseover", function(){
			g.isEmitted = true;
		});
	
		var clickEvent = document.createEvent ("Event");
		clickEvent.initEvent ("mouseover", true, false);
		g.label.getNode().dispatchEvent (clickEvent);
		
		value_of(g.isEmitted).should_be_true();
	},
	"'mouseout' signal": function(){
		g.isEmitted = false;
	
		g.label.connect("mouseout", function(){
			g.isEmitted = true;
		});
	
		var clickEvent = document.createEvent ("Event");
		clickEvent.initEvent ("mouseout", true, false);
		g.label.getNode().dispatchEvent (clickEvent);
		
		value_of(g.isEmitted).should_be_true();
	},
	"gtk.Label": function(){
		value_of(g.label.getMinWidthComposite()).should_be(87);
		value_of(g.label.getMinHeightComposite()).should_be(21);
	},
	"setText()": function(){
		g.label.setText("foo");
		value_of(g.label.getText()).should_be("foo");
		value_of(g.label.getMinWidthComposite()).should_be(22);
		value_of(g.label.getMinHeightComposite()).should_be(21);
	},
	"setAttribute()": function(){
		g.label.setAttribute({border: '3px dashed orange', fontSize: '16px', fontWeight:'bold'});
		value_of(g.label.getMinWidthComposite()).should_be(98);
		value_of(g.label.getMinHeightComposite()).should_be(27);

		value_of(g.label._dom.style.border).should_be("3px dashed orange");
		value_of(g.label._dom.style.fontSize).should_be("16px")
	},
	"setSelectable(boolea)": function(){
		g.label.setSelectable(true);
		value_of(g.label._dom.className).should_be("gtk_selectable");

		g.label.setSelectable(false);
		value_of(g.label._dom.className).should_be("gtk_none_selectable");
	},
	"setWidthChars()": function(){
		g.label.setWidthChars(200);
		value_of(g.label.getMinWidthComposite()).should_be(200);
		value_of(g.label.getMinHeightComposite()).should_be(21);
	},
	"enableHoverStyle()": function(){
		g.label.enableHoverStyle();
		value_of(g.label.getNode().className).should_be("gtk_widget gtk_label gtk_label_enable_hover");
	},
	"enable": function(){
		g.label.enable();
		value_of(g.label.getNode().className).should_be("gtk_widget gtk_label");
	},
	"resizeWidthCompsite()": function(){
		g.label.resizeWidthComposite(100);
		value_of(g.label.getWidth()).should_be(100);

		g.label.resizeWidthComposite(10);
		value_of(g.label.getWidth()).should_be(87);
	},
	"resizeWidthCompsite()": function(){
		g.label.resizeHeightComposite(50);
		value_of(g.label.getHeight()).should_be(50);

		g.label.resizeHeightComposite(10);
		value_of(g.label.getHeight()).should_be(21);
	}
});
