describe("gtk.LabelStore", {
	"before_each": function(){
		g = {};
		g.label = new gtk.LabelStore();
		
		g.iterMock = mock(gtk.TreeIter);
		when(g.iterMock.getPath() ).thenReturn("0:");
	    anyInstance("gtk.TreeIter", g.iterMock);
	    
	    g.labelMock = mock(gtk.Label);
	    anyInstance("gtk.Label", g.labelMock);
	},
	
	"after_each": function(){
		g = {};
		verify();
	},
	"add(), should add object treeiter": function(){
	    g.iter1 = g.iterMock;
	    g.label.add(g.iter1);
	    value_of(g.label.getChildren()[0]).should_be(g.iter1);
	},
	"append(), should return treeiter":function(){
        g.iter1 = g.label.append({"leftLabel": g.labelMock, "rightLabel": g.labelMock}); 
        g.iter2 = g.label.append({"leftLabel": g.labelMock, "rightLabel": g.labelMock}); 
        value_of(g.label.children[0]).should_be(g.iter1);
	},
	"getChildren(), should return all children": function(){
        g.iter1 = g.label.append({"leftLabel": g.labelMock, "rightLabel": g.labelMock}); 
        g.iter2 = g.label.append({"leftLabel": g.labelMock, "rightLabel": g.labelMock});
        value_of(g.label.getChildren().length).should_be(2);
	},
	"getChildByPath(), should return child": function(){
	    g.iter1 = g.label.append({"leftLabel": g.labelMock, "rightLabel": g.labelMock}); 
        g.iter2 = g.label.append({"leftLabel": g.labelMock, "rightLabel": g.labelMock});
	    value_of(g.label.getChildByPath("0:")).should_be(g.iter1);
	},
	"getChildByPath(), should return null if not found": function(){
	    value_of(g.label.getChildByPath("0:")).should_be_null();
	},
	"getModelType(), should return class name of the object": function(){
	    value_of(g.label.getModelType()).should_be(gtk.LabelStore);
	}
});
