describe("gtk.ListStore", {
	"before_each": function(){
		g = {};
		g.liststore = new gtk.ListStore(gobject.TYPE_STRING);

		g.child = mock(gtk.TreeIter);
		g.child.setRow = function(){};
		when(g.child.add()).thenReturn(arguments);
		when(g.child.getPath()).thenReturn("0:");
		when(g.child.getValue()).thenReturn({"value" : "Boys Like Girls - Thunder"});
		anyInstance("gtk.TreeIter", g.child);
	},
	"after_each": function(){
		g = {};
		verify();
	},
	"append(null, row), return a gtk.TreeIter pointing to the top row": function(){
		g.liststore.append(['one']);
		g.liststore.append(['two']);
		g.liststore.append(['three']);
		value_of(g.liststore.children.length).should_be(3);
	},
	"add(g.child), then getChildren() will return the array of added children": function(){
		g.liststore.add(g.child);
		value_of(g.liststore.getChildren()[0]).should_be(g.child);
	},
	"remove(g.child), then getChild(child) will return null": function(){
		g.liststore.add(g.child);
		g.liststore.remove(g.child);
		value_of(g.liststore.getChild(0)).should_be_null();
	},
	"getChildByPath, should return child":function(){
       g.iter1 = g.liststore.append({"value": ['Boys Like Girls - Thunder']});
       value_of(g.liststore.getChildByPath("0:")).should_be(g.iter1);
	},
	"getChildByPath(), should return child":function(){
       value_of(g.liststore.getChildByPath("0:")).should_be(undefined);
	},
	"getChildren(), should return all children": function(){
	    g.liststore.append(['one']);
		g.liststore.append(['two']);
		value_of(g.liststore.getChildren().length).should_be(2);
	},
	"search(), should return child as an object of TreeIter": function(){
	    g.iter1 = g.liststore.append({"value": ['Boys Like Girls - Thunder']});
	    value_of(g.liststore.search("value","Boys")).should_be(g.iter1);
	},
	"getModelType, should return class name of the object": function(){
	    value_of(g.liststore.getModelType()).should_be(gtk.ListStore);
	},
	"getChild(), should return a child given an index": function(){
	    g.iter1 = g.liststore.append({"value": ['Boys Like Girls - ThunderTwo Better Than One']});
	    g.iter2 = g.liststore.append({"value": ['Boys Like Girls - ThunderTwo Better']});
	    value_of(g.liststore.getChild(0)).should_be(g.iter1);
	},
	"filter(), should return filtered children given value and value member": function(){
	    g.iter1 = g.liststore.append({"value": ['Boys Like Girls - Thunder']});
	    value_of(g.liststore.filter({"value": ['Boys Like Girls - Thunder']})[0]).should_be(g.iter1);
	}
});
