describe("gtk.ProgressBar", {
	"before_each": function() {
		g = {};
		
		g.widget = mock(gtk.Widget);
		g.widget._domObj = Dom.create({tag: 'div'});
		anyInstance("gtk.Widget", g.widget);
		g.progressBar = new gtk.ProgressBar();
	},
	"after_each": function(){
		g = {};
		verify();
	},
	"When I call setPulseStep() passing a value in double (0.50), then I get the same value when I call getPaulseStep()" : function() {
		var value = 0.50;
		value_of(parseFloat(value) > 0 && parseFloat(value) <= 1).should_be(true);
		g.progressBar.setPulseStep(value);
		value_of(g.progressBar.getPulseStep()).should_be(value);
	},
	"When I call setText(value), I will get value back from getText()": function() {
		var value = "testing";
		g.progressBar.setText(value);
		value_of(g.progressBar.getText()).should_be(value);
	},
	"When I call setOrientation() passing a progress bar orientation constant, then I will get the same orientation constant that I passed in, when I call getOrientation()": function() {
		var leftToRight = gtk.PROGRESS_LEFT_TO_RIGHT;
		g.progressBar.setOrientation(leftToRight);
		value_of(g.progressBar.getOrientation()).should_be(leftToRight);
	},
	"When I call setFraction(fraction), I will get fraction from getFraction()": function() {
		var fraction = 0.5;
		value_of(parseFloat(fraction) > 0 && parseFloat(fraction) <=1).should_be(true);
		g.progressBar.setFraction(fraction);
		value_of(g.progressBar.getFraction()).should_be(fraction);
	}
});
