describe("gtk.TreeIter", {
	"before_each": function(){
		g = {};
		g.treeiter = new gtk.TreeIter("0:");
	},
	"after_each": function(){
		g = {};
	},
	"getValue(), should return an object which has been set by method setRow()": function(){
	    g.value = [1,2];
	    g.treeiter.setRow(g.value);
	    value_of(g.treeiter.getValue()).should_be(g.value);
	},
	"updateValue()": function(){
		g.value = {"value": [1,2]}
		g.newValue = {"value": [3,4]};
	    g.treeiter.setRow(g.value);

		g.treeiter.updateValue(g.newValue);
	    value_of(g.treeiter.getValue()["value"]).should_be(g.newValue);
	},
	"copy(), should return an object of gtk treeiter":function(){
	    g.copyOfTreeIter = g.treeiter.copy();
	    value_of(g.copyOfTreeIter).should_be(g.treeiter);
	},
	"getChildByPath(), should return child":function(){
	    g.child1 =  new gtk.TreeIter("0:0:");
	    g.child2 = new gtk.TreeIter("0:1:");
	    g.treeiter.add(g.child1);
	    g.treeiter.add(g.child2);
	    g.foundChild = g.treeiter.getChildByPath("0:");
	    value_of(g.foundChild).should_be(g.child1);
	},
	"getPath(), should return path": function(){
	    value_of(g.treeiter.getPath()).should_be("0:");
	},
	"getChildren(), should return all children": function(){
	    g.child1 =  new gtk.TreeIter("0:0:");
	    g.treeiter.add(g.child1);
	    value_of(g.treeiter.getChildren().length).should_be(1);
	},
	"remove(), should delete child": function(){
	    g.child1 =  new gtk.TreeIter("0:0:");
	    g.child2 = new gtk.TreeIter("0:1:");
	    g.treeiter.add(g.child1);
	    g.treeiter.add(g.child2);
	    g.treeiter.remove(g.child1);
	    value_of(g.treeiter.getChild(0)).should_be(g.child2);
	},
	"getChild(), should return child": function(){
	    g.child1 =  new gtk.TreeIter("0:0:");
	    g.child2 = new gtk.TreeIter("0:1:");
	    g.treeiter.add(g.child1);
	    g.treeiter.add(g.child2);
	    value_of(g.treeiter.getChild(1)).should_be(g.child2);
	},
	"getChild(), should return child": function(){
	    value_of(g.treeiter.getChild(1)).should_be_null;
	},
	"getChldBy(valueMember, value), should return a value object": function(){
	    g.valueObj = {"value": "FOO AND BAR", "id": 14};
		g.treeiter.setRow(g.valueObj);
	    value_of(g.treeiter.getChldBy("id", 14).getValue()).should_be(g.valueObj);
	}
});
