describe("gtk.TreeStore", {
	"before_each": function(){
		g = {};
		g.treestore = new gtk.TreeStore(gobject.TYPE_STRING);
	},
	"after_each": function(){
		g = {};
	},
	"append(null, row), return a gtk.TreeIter pointing to the top row": function(){
		g.iter = g.treestore.append(null, {"id": 1});
		g.treestore.append(null, {"id": 2});
		g.treestore.append(null, {"id": 3});
		
		value_of(typeof g.iter).should_be("object");
		value_of(g.treestore.children.length).should_be(3);
	},
	"append(parent, row)": function(){
		g.iter = g.treestore.append(null, {"id": 1});
		g.treestore.append(g.iter, {"id": 2});
		g.treestore.append(g.iter, {"id": 3});
		value_of(g.iter.getChildren().length).should_be(2);
	},
	"appendNodes(parent, rows)": function(){
		g.iter = g.treestore.append(null, ['one']);
		g.iters = g.treestore.appendNodes(
			g.iter, 
			[	
				{"display": "wow wow west", "hasChild": true},
				{"display": "never be the same"}
			]
		);
		value_of(g.iter.getChildren().length).should_be(2);
		value_of(g.iters[0] instanceof gtk.TreeIter).should_be_true();
	},
	"getChldBy()": function(){
		g.iter = g.treestore.append(null, {"id": 1});
		g.iter1 = g.treestore.append(g.iter, {"id": 2});
		g.iter2 = g.treestore.append(g.iter1, {"id": 3});
		value_of(g.treestore.getChldBy("id", 3)).should_be(g.iter2);
	},
	"getChildByIndex()": function(){
		g.iter = g.treestore.append(null, {"id": 1});
		g.iter1 = g.treestore.append(null, {"id": 2});
		g.treestore.append(null, {"id": 3});
		value_of(g.treestore.getChildByIndex(0)).should_be(g.iter);
		value_of(g.treestore.getChildByIndex(1)).should_be(g.iter1);
	},
	"getChildByPath()": function(){
		g.iter = g.treestore.append(null, {"id": 1});
		g.iter1 = g.treestore.append(g.iter, {"id": 2});
		g.iter2 = g.treestore.append(g.iter1, {"id": 3});
		value_of(g.treestore.getChildByPath("0:0:0:")).should_be(g.iter2);
	},
	"search()": function(){
		g.iter = g.treestore.append(null, {"id": 1, "display": "foo"});
		g.iter1 = g.treestore.append(g.iter, {"id": 2, "display": "bar"});
		g.iter2 = g.treestore.append(g.iter1, {"id": 3, "display": "foo bar"});
		value_of(g.treestore.search("foo")).should_be(g.iter2);
	}
});
