describe("gtk.VPaned", {
	"before_each": function(){
		g = {};

		//mock image
		g.image = mock(gtk.Image);
		g.image.show = function(){};
		g.image._domObj = Dom.create({tag: 'div'});
		anyInstance("gtk.Image", g.image);
		
		//mock paned
		g.paned = mock(gtk.Paned);
		g.value = 0;
		when( g.paned.getChild1() ).thenReturn(g.image._domObj);
		when( g.paned.getChild2() ).thenReturn(g.image._domObj);
		g.paned.setPosition = function(){ g.value = 10; }
		when( g.paned.getPosition() ).thenReturn(10);
		anyInstance("gtk.Paned", g.paned);
		g.paned._domObj = Dom.create({tag: 'div'});
		g.paned.show = function(){};
		g.vpaned =  new gtk.VPaned();
	},
	"after_each": function(){
		g = {};
		verify();
	},
	"when I call gtk.VPaned.add1(widget), I will get widget from gtk.VPaned.getChild1()": function(){
		g.vpaned.add1(g.image);
		g.vpaned.show();
		value_of(g.vpaned.getChild1()).should_be(g.image._domObj);
	},
	"when I call gtk.VPaned.add2(widget), I will get widget from gtk.VPaned.getChild2()": function(){
		g.vpaned.add2(g.image);
		g.vpaned.show();
		value_of(g.vpaned.getChild2()).should_be(g.image._domObj);
	},
	"when I call gtk.VPaned.pack1(widget), I will get widget from gtk.VPaned.getChild1()": function(){
		g.vpaned.pack1(g.image);
		g.vpaned.show();
		value_of(g.vpaned.getChild1()).should_be(g.image._domObj);
	},
	"when I call gtk.VPaned.pack2(widget), I will get widget from gtk.VPaned.getChild2()": function(){
		g.vpaned.pack2(g.image);
		g.vpaned.show();
		value_of(g.vpaned.getChild2()).should_be(g.image._domObj);
	},
	"when I call gtk.VPaned.setPosition(g.value), I will get g.value from gtk.VPaned.getPosition()": function(){
		g.vpaned.pack2(g.image);
		g.vpaned.show();
		g.vpaned.setPosition(g.value)
		value_of(g.vpaned.getPosition()).should_be(g.value);
	}
});
