/** @private */
gtk.EntryDropDownController = function(view, model){
	this.__selectedNodeData = null;
	this._view = view;
	this._model = model;
	this._initEvent();	
};

/** @private */
gtk.EntryDropDownController.prototype._initEvent = function(){
	var self = this;
    this._view.connect("_modelfiltered", function(value){
        self._performFilterAction(value); 
    });

	this._view.connect("_searchbypath", function(path){
		var child = self._model.getChildByPath(path);
		var value = child.getValue();

		self._view._setSelectedRowValue(value);
		self._view.setText(value["display"]);
		self._view._hideDropDown();
		self._view.setFocus();

 		self._view.emit("selected", value);
    });
    
    this._view.connect("_checkvaluechanged", function(value){
		var childModel = self._model.getChldBy("display", value);
		var foundValue = value;
		if(typeof childModel !== 'undefined'){
		    foundValue = childModel.getValue();
		    self._view._setSelectedRowValue(foundValue);
		}
    });

	this._view.connect("_searchbyindex", function(index){
		var childModel = self._model.getChildByIndex(index);
	    if(childModel !== null){
	        var valueObj = childModel.getValue();
		    self._view._setSelectedRowValue(valueObj);
		    self._view.setText(valueObj["display"]);
		    self._view.emit("selected", valueObj);
	    }		
	});

	this._view.connect("_searchModelByValueMember", function(valueMember, value){
		var childModel = self._model.getChldBy(valueMember, value);
		if(typeof childModel !== 'undefined'){
		    var valueObj = childModel.getValue();
		    self._view._setSelectedRowValue(valueObj);
		    self._view.setText(valueObj["display"]);
		}
	});
};

/** @private */
gtk.EntryDropDownController.prototype._performFilterAction = function(value){
    var validValue = jsgtk.Util.trim(value);
    if(validValue != ""){
        var filteredModel = this._model.filter(validValue);
        var data = this.__mashupModel(filteredModel);
        this._view._renderDropDown(data);
    }
    else{
        this._view._hideDropDown();
    }
};

/** @private */
gtk.EntryDropDownController.prototype.__mashupModel = function(nodes){
    var data = [];
    for(var i = 0, len = nodes.length; i < len; i++){
        data.push({"display": nodes[i].getValue()["display"], "path": nodes[i].getPath()});
    }
    return data;
};
