/** 
 * Item is an assistant class to create menu item
 * @constructor
 * @base gtk.Widget
 * @see gtk.Menu
 * @see gtk.MenuItem
 */
gtk.Item = function(){
	gtk.Widget.apply(this);
	var self = this;
	this._toggle = false;
	
	/** A registered signal name 'selected' */
	this.ITEM_SELECTED 		= "";
	/** A registered signal name 'deselected' */
	this.ITEM_DESELECTED	= "";
	/** A registered signal name 'toggled' */
	this.ITEM_TOGGLED		= "";

	this._render = function(){
		this._domObj.className += ' item';
	};
		
	this._render();
};

gtk.Item.prototype = new gtk.Widget();
gtk.Item.prototype.constructor = gtk.Item;

/**
 * A method to set menu selected
 */
gtk.Item.prototype.select = function(){
	this.emit('selected');
};

/**
 * A method to set menu deselected
 */
gtk.Item.prototype.deselect = function(){
	this.emit('deselected');
};

/**
 * A method to set toggled of the menu
 */
gtk.Item.prototype.toggle = function(){
	this.emit('toggled');
	if(this._toggle) this._toggle = false;
	else this._toggle = true;
};

gobject.signalNew('selected', gtk.Button, null, null, []);
gobject.signalNew('deselected', gtk.Button, null, null, []);
gobject.signalNew('toggled', gtk.Button, null, null, []);

