/**
 * Class gtk.LabelStore
 * Constructor: one or more column types
 * follow composite pattern: ListStore will contains one or more treeiter
 */
gtk.LabelStore = function(){
 	gtk.Object.apply(this);
	this._modelType = gtk.LabelStore;
 	this.children   = new Array();
 };
 
gtk.LabelStore.prototype = new gtk.Object();
gtk.LabelStore.prototype.constructor = gtk.LabelStore;

/**
 * The append() method appends a new row to the liststore
 * row : a tuple or list containing ordered column values to be set in the new row
 * @return {object} a gtk.TreeIter pointing to the new row
 */
gtk.LabelStore.prototype.append = function(row){
	var iter = new gtk.TreeIter(this.children.length.toString() + ':');
	iter.setRow(row);
	this.add(iter);
	return iter;
};

gtk.LabelStore.prototype.getChildByPath = function(path){
    for(var i = this.children.length; i--;){
        var child = this.children[i];
        if(child.getPath() === path) return child;
    }
    return null;
};

gtk.LabelStore.prototype.getModelType = function(){
	return this._modelType;
};

gtk.LabelStore.prototype.getChildren = function(){
	return this.children;
};

gtk.LabelStore.prototype.add = function(child){
	this.children.push(child);
};
