/**
 * The base class of gtk.HPaned and gtk.HPaned
 * @constructor
 * @base gtk.Widget
 * @see gtk.VPaned
 */
gtk.Paned = function(){
	gtk.Widget.apply(this);

	this._minWidth = 200;
	this._minHeight = 200;
	this._width = this._minWidth;
	this._height = this._minHeight;
	
	/** @private */
	this._render = function(){
		this._domObj.className += " gtk_paned";
	};

	this._render();	
};

gtk.Paned.prototype = new gtk.Widget();
gtk.Paned.prototype.constructor = gtk.Paned;

/**
 * Adds the widget specified by child to the top or left of the paned
 * @param {gtk.Widget} widget
 */
gtk.Paned.prototype.pack1 = function(widget){
	this._child1 = widget;
	this._paned1.appendChild(this._child1.getNode());
	this._resizePaned1(true);
};

/**
 * Adds the widget specified by child to the top or left of the paned
 * @param {gtk.Widget} widget
 */
gtk.Paned.prototype.pack2 = function(widget){
	this._child2 = widget;	
	this._paned2.appendChild(this._child2.getNode());
	this._resizePaned2(true);
};

/** @private */
gtk.Paned.prototype.resize = function(width, height){
	this._resizePaned1(false);
	this._resizePaned2(false);
};

/** @private */
gtk.Paned.prototype._resizePaned1 = function(isInit){
	this._resizePaned1Width(isInit);
	this._resizePaned1Height(isInit);
};

/** @private */
gtk.Paned.prototype._resizePaned2 = function(isInit){
	this._resizePaned2Width(isInit);
	this._resizePaned2Height(isInit);
};

/** @private */
gtk.Paned.prototype._showGhostDivider = function(){
	var ghostDividerStyle = this._ghostDivider.style;
	ghostDividerStyle.backgroundColor = "#838B8B";
	ghostDividerStyle.opacity = 1;
};

/** @private */
gtk.Paned.prototype._hideGhostDivider = function(){
	var ghostDividerStyle = this._ghostDivider.style;
	ghostDividerStyle.disply = "none";
	ghostDividerStyle.opacity = 0.1;
};

gobject.signalNew("childrendminimize", gtk.Paned, null, null, []);
gobject.signalNew("childrestore", gtk.Paned, null, null, []);
