/**
 * PopupWindowInfo is a class to create pop-up window type Info
 * @param {String} title The header title of the pop-up window
 * @param {String} textMessage The body text/content of the pop-up window
 * @constructor
 * @base gtk.PopupWindowDefault
 * @extends gtk.PopupWindowDefault
 */
gtk.PopupWindowInfo = function(title, textMessage){
    gtk.PopupWindowDefault.apply(this, [title, textMessage]);
    this._iconWidth = 95;
    
    this._render = function(){
        var imageDiv = jsgtk.Dom.create({"tag": "div", "className": "gtk_popup_window_info_image"});
        this._body.insertBefore(imageDiv,this._bodyDiv);
        this._bodyDiv.style.margin = "0px 0px 0px 66px";  
    }; 
    this._render();
};

gtk.PopupWindowInfo.prototype = new gtk.PopupWindowDefault();
gtk.PopupWindowInfo.prototype.constructor = gtk.PopupWindowInfo;
