/**
 * VScroller is a class to create a vertical scroller. The vertical scroller has only vertical scrollbar
 * @base gtk.Scroller
 * @see gtk.Scroller
 * @constructor
 */
gtk.VScroller = function() {
	gtk.Scroller.apply(this);
	this._scollerWidth = 18;
	this.disableHScrolled();
};

gtk.VScroller.prototype = new gtk.Scroller();
gtk.VScroller.prototype.constructor = gtk.VScroller;

/**
 * A method to get width of the scroll window
 * @return {Integer} The minimum composite width of the scroll
 * @type Integer
 */
gtk.VScroller.prototype.getMinWidthComposite = function(){
	var childMinWidth = this._child.getMinWidthComposite();
	return this._minWidth > childMinWidth ? this._minWidth : childMinWidth;
};

/**
 * A method to resize width of the scroll window
 * @param {Integer} width The composite width value in pixel to be set
 */
gtk.VScroller.prototype.resizeWidthComposite = function(width){
	var _width = width - this._padding*2;
	
	var minWidth = this.getMinWidthComposite();
	minWidth = _width > minWidth ? _width : minWidth;
	
	this._resizeWidth(minWidth);

    this._child.resizeWidthComposite(minWidth - this._scollerWidth);

	if(this._child instanceof gtk.ListView) this._child.setParentWidth(minWidth);
};
