/*
* class gtk.SmartEntryDropDownDynamicController
*/
gtk.SmartEntryDropDownDynamicController = function(view){
	var self = this;
	this._view = view;
	this._model = null;

	this._render = function(model, parentNode){
		var mashedUpdata = this.__mashupModel(model.getChildren());
		view._renderDropDown(mashedUpdata, parentNode);
	};

	this._view.connect("_rendersubnodes", function(path, parentNode){
		var childModel = self._model.getChildByPath(path);
		self._render(childModel, parentNode);
	});	
	
	this._view.connect("_search", function(value){
		var model = self._model.search(value);
		var path = model ? model.getPath() : "";
		view._hilightRow(path);
	});
};

gtk.SmartEntryDropDownDynamicController.prototype.setModel = function(model){
	this._model = model;
	var mashedUpdata = this.__mashupModel(this._model.getChildren());
	this._view._renderDropDown(mashedUpdata, null);
};

gtk.SmartEntryDropDownDynamicController.prototype.__mashupModel = function(nodes){
    var data = [], node, hasChild;
    for(var i = 0, len = nodes.length; i < len; i++){
        node = nodes[i];
        hasChild = node.getChildren().length  > 0;
        data.push({"display": node.getValue()["display"], "hasChildNodes": hasChild, "path": node.getPath(), "valueObject": node.getValue()});
    }
    return data;
};
