/*
* class gtk.SmartEntryDropDownController
*/
gtk.SmartEntryDropDownLabelController = function(){
	this.__model = new gtk.SmartEntryDropDownLabelModel();
};

gtk.SmartEntryDropDownLabelController.prototype._setModel = function(view, model, label, width){
	var self = this;
	var dropDownView = new gtk.DropDownView();
	dropDownView.constructView(model, label);
	var dropDown = dropDownView._getDom();
	view._appendDropDown(dropDown);
	
	dropDownView._updateSize(width);
	this.__model._addChild(dropDownView);
	
	this.__connectEvent(dropDownView);
};

gtk.SmartEntryDropDownLabelController.prototype._createView = function(view, label, width){
	var entryTag = new gtk.EntryTag(label);
	view._appendEntry(entryTag);
	
	entryTag._updateSize(width);
	this.__model._addChild(entryTag);	
	
	this.__connectEvent(entryTag);
};

gtk.SmartEntryDropDownLabelController.prototype.__connectEvent = function(widget){
	var self = this;
	widget.connect("_enterkeypressed", function(currentChild){
		var nextChild = self.__model._getNextChild(currentChild);
		if(nextChild){
			nextChild._setFocus();
		};
	});
	
	widget.connect("_backspacekeypressed", function(currentChild){
		var previousChild = self.__model._getPreviousChild(currentChild);
		if(!previousChild) return;
		previousChild._getSelected() ? previousChild._deleteTag() : previousChild._selectTag();
	});
	
	widget.connect("_deletekeypressed", function(currentChild){
		var previousChild = self.__model._getPreviousChild(currentChild);
		if(!previousChild) return;
		if(previousChild._getSelected()) previousChild._deleteTag();
	});	
};

gtk.SmartEntryDropDownLabelController.prototype._updateChildrenWidth = function(width){
	var children = this.__model._getChildren();
	for(var i = children.length -1; i--;){
		children[i]._updateSize(width);
	}
};

gtk.SmartEntryDropDownLabelController.prototype._getChildrenItems = function(){
	var children = this.__model._getChildren();
	var items = [];

	for(var i = 0, len = children.length; i < len; i++){
		items.push(children[i]._getItem());
	}
	
	return items;
};

gtk.SmartEntryDropDownLabelController.prototype._createTag = function(obj, index){
	this.__model._getChildren()[index]._setTag(obj);
};
