gtk.SmartEntryDropDownRendere = function(host){
	this._host = host;
	this._selectedRowNode = null;
	this._domDownNode = this._host.__dropDown;
};

gtk.SmartEntryDropDownRendere.prototype.getSelectedRowNode = function(){
	return this._selectedRowNode;
};

gtk.SmartEntryDropDownRendere.prototype.setSelectedRowNode = function(selectedRowNode){
	this._selectedRowNode = selectedRowNode;
};

gtk.SmartEntryDropDownRendere.prototype._positionRowNode = function(rowNode, path){
	rowNode.style.paddingLeft = 15 * ( path.split(":").length/2 - 1 ) + 5 + "px";
};

gtk.SmartEntryDropDownRendere.prototype._deHilightSelectedRow = function(){
	if(this._selectedRowNode){
		this._selectedRowNode.className = "gtk_smart_entry_drop_down_element";
		this._selectedRowNode = null;
	}
};

gtk.SmartEntryDropDownRendere.prototype._hilightElement = function(index){
	this._selectedRowNode.className += " gtk_smart_entry_drop_down_selected";
};

gtk.SmartEntryDropDownRendere.prototype.hilightRowNode = function(rowNode, index){
	this._deHilightSelectedRow();
	this._selectedRowNode = rowNode;
	this._hilightElement(index);
};

gtk.SmartEntryDropDownRendere.prototype.hilightNextRowNode = function(){
	var nextNode = this._getNextSelectableNode(this._selectedRowNode);
	this.hilightRowNode(nextNode);
	this._scrollToHilightedRow();
};

gtk.SmartEntryDropDownRendere.prototype.hilightPreviousRowNode = function(){
	var previousNode = this._getPreviousSelectableNode(this._selectedRowNode) || this._selectedRowNode;
	this.hilightRowNode(previousNode);
	this._scrollToHilightedRow();

};

gtk.SmartEntryDropDownRendere.prototype.hilightRowById = function(path){
	if(path !== ""){
		var tempDom = this._domDownNode.cloneNode(true).childNodes;
		for(var i = 0, len = tempDom.length; i < len; i++)
			if(tempDom[i].id == path){
				this.hilightRowNode(this._domDownNode.childNodes[i], i);
				this._scrollToHilightedRow();
				break;
			}
	}else
		this._deHilightSelectedRow();
};

/** @private */
gtk.SmartEntryDropDownRendere.prototype._getSelectedNodeIndex = function(){
	var rowNodes = this._domDownNode.cloneNode(true).childNodes;
	for(var i = 0, len = rowNodes.length; i < len; i++){
		if(jsgtk.Util.isMatched("gtk_smart_entry_drop_down_selected", rowNodes[i].className))
			break;
	}
	return i;
};

gtk.SmartEntryDropDownRendere.prototype._scrollToHilightedRow = function(){
	var index = this._getSelectedNodeIndex();
    this._domDownNode.scrollTop = index * 16;
};

gtk.SmartEntryDropDownRendere.prototype._constructRowNodes = function(children, parent){
	var parentNode = parent || document.createDocumentFragment();

	for(var i = 0, len = children.length; i < len; i++){
		var child = children[i];
		var element = jsgtk.Dom.create({tag: "div", append: parentNode, text: child["display"], "id": child.path, className: "gtk_smart_entry_drop_down_element"});
		if(child.hasChildNodes) {
			element.className = "gtk_smart_entry_drop_down_group";
			this._host.emit("_rendersubnodes", child.path, parentNode);
		}
		this._positionRowNode(element, child.path);
		element.valueObject = child["valueObject"];
	}
	return parentNode;
};

gtk.SmartEntryDropDownRendere.prototype._getPreviousSelectableNode = function(currentNode){
	var currentNode = currentNode;
	var previousSelectableNode = currentNode? currentNode.previousSibling : this._domDownNode.lastChild;
	if(!previousSelectableNode) return;

	var isDropDownElement = jsgtk.Util.isMatched("gtk_smart_entry_drop_down_element", previousSelectableNode.className);	
	previousSelectableNode = isDropDownElement ? previousSelectableNode : this._getPreviousSelectableNode(previousSelectableNode);
	return previousSelectableNode;
};

gtk.SmartEntryDropDownRendere.prototype._getNextSelectableNode = function(currentNode){
	var currentNode = currentNode || this._domDownNode.firstChild;
	var nextSeletableNode = currentNode.nextSibling || currentNode;

	var isDropDownElement = jsgtk.Util.isMatched("gtk_smart_entry_drop_down_element", nextSeletableNode.className);
	nextSeletableNode = isDropDownElement ? nextSeletableNode : this._getNextSelectableNode(nextSeletableNode);
	return nextSeletableNode;
};
