gtk.SmartEntryDropDownFixedModel = function(){
    gtk.SmartEntryDropDown.apply(this);

	this._initEvent();
	this._tagRendere = new gtk.SmartEntryTagRendere(this);
	this._dropDownRendere = new gtk.SmartEntryDropDownRendere(this);
	this._controller = new gtk.SmartEntryDropDownFixedModelController(this);
};

gtk.SmartEntryDropDownFixedModel.prototype = new gtk.SmartEntryDropDown();
gtk.SmartEntryDropDownFixedModel.prototype.constructor = gtk.SmartEntryDropDownFixedModel;

/** @private */
gtk.SmartEntryDropDownFixedModel.prototype.__bindInputEvent = function(){
	var jsgtkEvent = jsgtk.Event, self = this;
	var entryValue = "";
	
	jsgtkEvent.addDomListener(this._entry, "keypress", function(e){
		//do this to use in backspace event
		entryValue = self._entry.value;	
	});
		
	jsgtkEvent.addDomListener(this._entry, "keyup", function(e){

		if(self._isCtrlAKeyPressed(e)){
			if(entryValue) return;
			self._selectAllTags();
			return;
		}
		
		switch(e.keyCode){
			case gtk.DOWN_ARROW_KEY:
				self.__fireDownArrowKey();
				return;
			case gtk.UP_ARROW_KEY:
				self.__fireUpArrowKey();
				return
			case gtk.LEFT_ARROW_KEY:
				self.__fireLeftArrowKey();
				return;
			case gtk.RIGHT_ARROW_KEY:
				self.__fireRightArrowKey();
				return;
			case gtk.ENTER_KEY:
				self.__fireEnterKey();
				return;
			case gtk.BACKSPACE_KEY:
				self.__fireBackSpace(entryValue);
				break;
			case gtk.DELETE_KEY:
				self.__fireDeleteKey();
				return;
			default:
		}
		
		if(((e.which == gtk.A_KEY || e.which == gtk.CAP_A_KEY) && e.ctrlKey) || e.ctrlKey){
			self.__hideDropDown();
			return;
		}
		if(e.keyCode == gtk.BACKSPACE_KEY && self._entry.value == ""){
			self.__hideDropDown();
			return;
		}
		
		if(self._entry.value){
			var isLastTagSelected = self._tagHolder.lastChild && self._tagHolder.lastChild.selected;
			if(isLastTagSelected){
				self._tagRendere.unSelectTags();
			};
			self.__hideLabel();
			self.__showDropDown();
			
			self._resetDropDownPosition();

			self.emit("_search", self._entry.value);
		}
	});
};
