gtk.SmartEntryTagRendere = function(host){
	this._host = host;
	this._tagHolder = this._host._tagHolder;
	this._selectedTag = null;
};

gtk.SmartEntryTagRendere.prototype.getSelectedTag = function(){
	return this._selectedTag;
};

gtk.SmartEntryTagRendere.prototype.setSelectedTag = function(selectedTag){
	this._selectedTag = selectedTag;
};

gtk.SmartEntryTagRendere.prototype._createTag = function(value, selectedRowNode){
	var tagValue = value || this._host._entry.value;
	if(tagValue){
        var self = this;
        var tag = jsgtk.Dom.create({"tag": "div", "className": "gtk_smart_entry_drop_down_tag_holder"});

        	var spanTag  = jsgtk.Dom.create({"tag": "span", "append": tag , "text": tagValue});
        	var closeButton = jsgtk.Dom.create({"tag": "div", append: tag , "className": "gtk_smart_entry_drop_down_close"});
        
        jsgtk.Event.addDomListener(closeButton, "click", function(e){
            self._tagHolder.removeChild(tag);
        }, false);

		tag.path = selectedRowNode && selectedRowNode["id"] || "";
		tag.selected = false;
		tag.valueObject = selectedRowNode && selectedRowNode["valueObject"];

        return tag;
    }
};

/** @private */
gtk.SmartEntryTagRendere.prototype.unSelectTags = function(){
    var tags = this._tagHolder.childNodes;
        
    for(var i = tags.length; i--;){
        if(tags[i].selected == true){
            tags[i].selected = false;
            tags[i].className = "gtk_smart_entry_drop_down_tag_holder";
        }
    }
	this._selectedTag = null;
};

gtk.SmartEntryTagRendere.prototype.selectTag = function(tag){
	this._selectedTag = tag;
    this._selectedTag.selected = true;
    this._selectedTag.className = "gtk_smart_entry_drop_down_tag_selected";
};

gtk.SmartEntryTagRendere.prototype.unSelectTag = function(){
	if(this._selectedTag){
		this._selectedTag.selected = false;
		this._selectedTag.className = "gtk_smart_entry_drop_down_tag_holder";
		this._selectedTag = null;
	}
};

gtk.SmartEntryTagRendere.prototype.selectTag = function(tag){
	this._selectedTag = tag;
    this._selectedTag.selected = true;
    this._selectedTag.className = "gtk_smart_entry_drop_down_tag_selected";
};

gtk.SmartEntryTagRendere.prototype.selectTags = function(){
    var tags = this._tagHolder.childNodes;
        
    for(var i = tags.length; i--;){
    	var tag = tags[i];
    	if(tag.firstChild.className == "gtk_smart_entry_drop_down_fixed_tag"){
    		continue;
    	}
        tag.selected = true;
        tag.className += " gtk_smart_entry_drop_down_tag_selected";
    }
};

gtk.SmartEntryTagRendere.prototype.isTagExisted = function(){
	var tags = this._tagHolder.childNodes;
	return tags.length == 0 ? false : true;
};

gtk.SmartEntryTagRendere.prototype.isNextTagExisted = function(){
	return this._selectedTag.nextSibling;
};

gtk.SmartEntryTagRendere.prototype.isPreviousTagExisted = function(){
	var tags = this._tagHolder.childNodes;
	var tag = this._selectedTag ? this._selectedTag.previousSibling : tags[tags.length-1];
	return tag;
};

gtk.SmartEntryTagRendere.prototype.isFixedTag = function(tag){
	return jsgtk.Util.isMatched("gtk_smart_entry_drop_down_fixed_tag", tag.firstChild.className);
};
