/**
* Factory class for gtk.Table
* @constructor
* @param {integer} rows number of row of table
* @param {integer} columns number of column of table
* @param {boolean} homogeneous
* <br> - homogeneous = true will return gtk.TableHomogenoues
* <br> - homogeneous = false will return gtk.TableNoneHomogenoues
* @param {boolean} resizeable
* <br> - resizeable = true will make all children expand to fill table
* <bt> - resizeable = false all children will be packed to the most top and most left of table
* @param {integer} spacing between each child
*/
gtk.TableFactory = function(rows, columns, homogeneous, resizeable, spacing) {
	return homogeneous ? 
	       new gtk.TableHomogenoues(rows, columns, resizeable, spacing) : 
	       new gtk.TableNoneHomogenoues(rows, columns, resizeable, spacing);
};
