/**
 * A class used to create Rich Text Editor
 * @constructor
 * 
 */
gtk.TextEditor = function(defaultValue){
      gtk.Widget.apply(this); 
      var self 					= this;
      this._width 				= this._minWidth 	= 500; 
      this._height 				= this._minHeight = 200;
      this._defaultValue 		= defaultValue || "";
      this._arrayColorBoxDom 	= [];
      this._isEditable			= true;
      this._disabledModal		= null;
      this._maxLength			= Number.MAX_VALUE;
      this._remainingLength		= Number.MAX_VALUE;
      
      this._showControlBox		= false;
      this._showError			= true;
      this._arrayColorCode 	= [
                                ["FFFFFF", "B7B7B7", "8E8E8E", "5B5B5B", "515151", "282828", "1E1E1E", "000000"],
                                ["FFC1C1", "F08080", "FF6A6A", "FD0500", "EE0000", "CD0000", "8B0000", "8B2500"],
                                ["E3A869", "ED9121", "FF8C00", "FF7F00", "FF8000", "EE7600", "CD6600", "8B4500"],
                                ["FFFFE0", "FFF68F", "FFFF00", "F7F868", "FCFE01", "E7E90B", "C8CA07", "808000"],
                                ["C1FFC1", "9AFF9A", "90F878", "00FF00", "00CD00", "008B00", "006400", "185f07"],
                                ["BBFFFF", "8DEEEE", "00FFFF", "00EEEE", "00CDCD", "03A89E", "008080", "2F4F4F"],
                                ["CAE1FF", "63B8FF", "5CACEE", "1C86EE", "1874CD", "0000FF", "104E8B", "191970"],
                                ["FFBBFF", "EE82EE", "FF00FF", "BF3EFF", "9400D3", "7D26CD", "551A8B", "4B0082"]
                              ];
      this._arrayFontType = ["Arial", "Comic Sans MS", "Courier New", "Georgia", "Helvetica","Narrow", "Sans Serif", "Tahoma", "Times New Roman", "Verdana"];
      this._render = function(){
        this._domObj.className += " gtk_text_editor";
            this._domToolbar = jsgtk.Dom.create({append: this._domObj, tag: "div", className:"gtk_text_editor_toolbar"});
          
            this._buttonBold = new gtk.TextEditorToolbar("bold", " Bold ", this._domToolbar);
            this._buttonItalic = new gtk.TextEditorToolbar("italic", " Italic ", this._domToolbar);
            this._buttonUnderline = new gtk.TextEditorToolbar("underline", " Underline ", this._domToolbar);
            this._buttonStrikethrough = new gtk.TextEditorToolbar("strikethrough", " Strikethrough ", this._domToolbar);
              
            this._buttonJustifyLeft = new gtk.TextEditorToolbar("justifyleft", " Left Alignment ", this._domToolbar); 
            this._buttonJustifyCenter = new gtk.TextEditorToolbar("justifycenter", " Center Alignment ", this._domToolbar); 
            this._buttonJustifyRight = new gtk.TextEditorToolbar("justifyright", " Right Alignment ", this._domToolbar); 
            this._buttonJustifyFull = new gtk.TextEditorToolbar("justifyfull", " Full Alignment ", this._domToolbar); 
            
            this._buttonTextColor = new gtk.TextEditorToolbar("textcolor", " Text Color ", this._domToolbar); 
            this._divColorContainer = jsgtk.Dom.create({append: this._domToolbar, tag: "div", className:"gtk_text_editor_colorcontainer"});
            this._divColorRow = jsgtk.Dom.create({tag: "div", className:"gtk_text_editor_colorrow"});
            this._colorBox1 = jsgtk.Dom.create({tag: "span"});
            this._createColorBox();
            
            this._buttonHighlight = new gtk.TextEditorToolbar("highlight", " Highlight Color ", this._domToolbar); 
            this._divHighlightColor =  this._divColorContainer.cloneNode(true);
            this._divHighlightColor.className = "gtk_text_editor_highlight_container";
            this._domToolbar.appendChild(this._divHighlightColor);
            
            this._buttonFontType = new gtk.TextEditorToolbar("fonttype", " Font Type ", this._domToolbar); 
            this._divFontTypeContainer = jsgtk.Dom.create({append: this._domToolbar, tag: "div", className:"gtk_text_editor_fonttypecontainer"});
            this._createFontType();
            
            this._buttonFontSize = new gtk.TextEditorToolbar("fontsize", " Font Size ", this._domToolbar); 
            this._divFontSizeContainer = jsgtk.Dom.create({append: this._domToolbar,tag: "div", className:"gtk_text_editor_fontsizecontainer"});
            this._createFontSize();
            
            this._buttonLink = new gtk.TextEditorToolbar("link", " Link ", this._domToolbar);
           
            this._buttonBulletedList = new gtk.TextEditorToolbar("bulleted", " Bulleted List ", this._domToolbar); 
            this._buttonNumberedList= new gtk.TextEditorToolbar("numberedlist", " Numbered List ", this._domToolbar); 
            
            this._buttonIndent= new gtk.TextEditorToolbar("indent", " Indent Right ", this._domToolbar); 
            this._buttonOutdent= new gtk.TextEditorToolbar("outdent", " Outdent Left ", this._domToolbar);
            this._buttonRemoveStyle= new gtk.TextEditorToolbar("removestyle", " Remove Format ", this._domToolbar); 
            
            this._iFrameDiv = jsgtk.Dom.create({tag: "div", className:"gtk_text_editor_iframediv"});
            this._iFrameDomobj = jsgtk.Dom.create({append: this._iFrameDiv, tag: "iframe", className:"gtk_text_editor_iframe"});
            
            this._controlBox = jsgtk.Dom.create({tag: "div", className:"gtk_text_editor_controlbox"});
            this._progressbar = jsgtk.Dom.create({tag: "div", append: this._controlBox, className:"gtk_text_editor_progressbar"});
            this._lengthBox = jsgtk.Dom.create({tag: "div", append: this._controlBox, className:"gtk_text_editor_length_box"});
            
            this._domObj.appendChild(this._iFrameDiv);
                        
            this._iFrameDomobj.onload = function(){
                self._iFrameInitEvent();
                self._setDefaultValue(self._defaultValue);
                if(self._showControlBox)
           			self._initMaxLength();
            };
            
            
            var domObjStyle = this._domObj.style;
            domObjStyle.width = this._width + "px";
            domObjStyle.height = this._height + "px";
                                               
            var iFrameStyle = this._iFrameDomobj.style;
            iFrameStyle.width = this._width - 2 + "px";
            iFrameStyle.height = this._height - 26 + "px";
        
      };
      this._render();     
      this._initEvent();
};

gtk.TextEditor.prototype = new gtk.Widget();
gtk.TextEditor.prototype.constructor = gtk.TextEditor;

/** @private */
gtk.TextEditor.prototype._createFontSize = function(){
    var domFontSize = jsgtk.Dom.create({tag: "span", className:"gtk_text_editor_fontsizetype"});
    for(var i=1;i<=7;i++){
       var fontSize = domFontSize.cloneNode(false);
       fontSize.innerHTML = "Size " + i;
       fontSize.style.fontSize = i + 6 + "pt";
       this._divFontSizeContainer.appendChild(fontSize);
    }
};

/** @private */
gtk.TextEditor.prototype._createFontType = function(){
    var domFontType = jsgtk.Dom.create({tag: "span", className:"gtk_text_editor_fontname"});
    for(var i=0;i<10;i++){
        var fontType = domFontType.cloneNode(false);
        fontType.innerHTML = this._arrayFontType[i];
        fontType.style.fontFamily = this._arrayFontType[i];
        this._divFontTypeContainer.appendChild(fontType);
    }
};

/** @private */
gtk.TextEditor.prototype._setStyle = function(styleName, argVal){
    var iFrameDoc = this._getIFrameDoc();
    iFrameDoc.execCommand(styleName, false, argVal);    
};
/**
 * Set maximum length of text in the TextEditor
 */
gtk.TextEditor.prototype.setMaxLength = function(maxLength){
    this._maxLength = this._remainingLength = maxLength;
    this._showControlBox = true;
};
/** @private */
gtk.TextEditor.prototype._showProgressBar = function(){
	var textLength = this.getText().length;
	var percentageOfWidth = (textLength * 81)/this._maxLength;
	this._progressbar.style.width = percentageOfWidth + "%";
};
/** @private */
gtk.TextEditor.prototype._initMaxLength = function(){
	var self = this;
	this._domObj.appendChild(this._controlBox);
	var textLength = this.getText().length;
	this._lengthBox.innerHTML = this._remainingLength-textLength + "/" + this._maxLength + "&nbsp;";
	this._showProgressBar();
	
	jsgtk.Event.addDomListener(this._getIFrameDoc(), "keypress", function(e){
		var textLength = self.getText().length;
		self._remainingLength = self._maxLength - textLength;
		if(textLength > self._maxLength){
			return;
		}
		self._lengthBox.innerHTML = self._remainingLength + "/" + self._maxLength + "&nbsp;";
		self._showProgressBar();               
	});
};

/**
 * Get/return HTML value from an iframe
 */
gtk.TextEditor.prototype.getValue = function(){
    return this._getIFrameDoc().body.innerHTML;
};
/**
 * Get/return plain text from an iframe
 */
gtk.TextEditor.prototype.getText = function(){
    return this._getIFrameDoc().lastChild.textContent;
};

/** @private */
gtk.TextEditor.prototype._setDefaultValue = function(value){
    this._getIFrameDoc().body.innerHTML = value;
};

/** @private */
gtk.TextEditor.prototype._createColorBox = function(){
    for(i=0;i<8;i++){
        var divColorRow = this._divColorRow.cloneNode(false);
        var marginLeft = 0;
        for(var j = 0;j<8;j++){
            var colorBox = this._colorBox1.cloneNode(false);
                colorBox.style.marginLeft = marginLeft + "px";
                colorBox.style.backgroundColor = "#" + this._arrayColorCode[i][j];
                divColorRow.appendChild(colorBox);
            this._arrayColorBoxDom.push(colorBox);
            marginLeft += 15;
        }
        this._divColorContainer.appendChild(divColorRow);
    }
};

/** @private */
gtk.TextEditor.prototype._setFontColor = function(colorCode){
    this._setStyle("ForeColor", colorCode);
};

/** @private */
gtk.TextEditor.prototype._setBackgroundColor = function(colorCode){
    this._setStyle("hiliteColor", colorCode);
};

/** @private */
gtk.TextEditor.prototype._setFontType = function(fontName){
    this._setStyle("fontName", fontName);
};

/** @private */
gtk.TextEditor.prototype._setFontSize = function(fontSize){
    this._setStyle("fontSize", parseInt(fontSize)-6);
};

/** @private */
gtk.TextEditor.prototype._getColorCode = function(colorBoxObj){
    return colorBoxObj.style.backgroundColor;
};

/** @private */
gtk.TextEditor.prototype._getFontSize = function(divFontSizeObj){
    return divFontSizeObj.style.fontSize;
};

/** @private */
gtk.TextEditor.prototype._getSelectedText = function(){
    var selectedText = this._getIFrameDoc().getSelection();
    return selectedText;
};

/** @private */
gtk.TextEditor.prototype._getCommandState = function(StyleCmd){
    var formatValue = false;
    if(StyleCmd !== null) formatValue = this._getIFrameDoc().queryCommandState(StyleCmd);
    return formatValue;
};

/** @private */
gtk.TextEditor.prototype._getIFrameDoc = (function(){
    var iFrameObj = this._iFrameDomobj;
    var iFrameDoc = iFrameObj.contentDocument || iFrameObj.contentWindow;
    return iFrameDoc.document ? iFrameDoc.document : iFrameDoc;
});

/** @private */
gtk.TextEditor.prototype._setEditableMode = function(isEditable){
	this._isEditable = (typeof isEditable !== 'undefined' && typeof isEditable === 'boolean') ? isEditable : true;
    var iFrameDoc = this._getIFrameDoc();
    iFrameDoc.designMode = this._isEditable ? "on" : "off";
};
/**
 *  Show or hide error
 *  @param{Boolean}, Boolean value whether true to show error or false
 */
gtk.TextEditor.prototype.showError = function(isOnError){
	this._showError = (typeof isOnError !== 'undefined' && typeof isOnError === 'boolean') ? isOnError : true;
    
    if(this._showError) this._domObj.className += " gtk_text_editor_onerror";
    else this._domObj.className = "gtk_widget gtk_text_editor";
};

/**
 *  Set cursor focus unto onload of the iframe
 */
gtk.TextEditor.prototype.setFocus = function(){
    var iFrameDoc = this._getIFrameDoc();
    this._iFrameDomobj.contentWindow.focus();
};

/** @private */
gtk.TextEditor.prototype._initEvent = function(){
    var self= this;
    var jsgtkEvent = jsgtk.Event;
    
    jsgtkEvent.addDomListener(this._buttonBold, "click", function(){ self._execCommand(self._buttonBold); });
    jsgtkEvent.addDomListener(this._buttonItalic, "click", function(){ self._execCommand(self._buttonItalic);});
    jsgtkEvent.addDomListener(this._buttonUnderline, "click", function(){ self._execCommand(self._buttonUnderline); });
    jsgtkEvent.addDomListener(this._buttonStrikethrough, "click", function(){self._execCommand(self._buttonStrikethrough);});
    jsgtkEvent.addDomListener(this._buttonJustifyLeft, "click", function(){
        self._execJustify(self._buttonJustifyLeft);
        self._buttonJustifyLeft._activate = true;
    });
    
    jsgtkEvent.addDomListener(this._buttonJustifyCenter, "click", function(){
        self._execJustify(self._buttonJustifyCenter);
        self.getValue();
        self._buttonJustifyCenter._activate = true;
    });
    
    jsgtkEvent.addDomListener(this._buttonJustifyRight, "click", function(){     
        self._execJustify(self._buttonJustifyRight);
        self._buttonJustifyRight._activate = true;
    });
    
    jsgtkEvent.addDomListener(this._buttonJustifyFull, "click", function(){
        self._execJustify(self._buttonJustifyFull);
        self._buttonJustifyFull._activate = true;
    });
    
    jsgtkEvent.addDomListener(this._buttonTextColor, "click", function(e){
        if(!self._isTextColorVisible){
            self._hideHighlightColorPicker();
            self._hideFontType();
            self._hideFontSize();
            self._showTextColorPicker();
            jsgtkEvent.stopBubble(e);
        }
        else{
            self._hideTextColorPicker();
            jsgtkEvent.stopBubble(e);
        }
        
    });
    jsgtkEvent.addDomListener(document.body, "click", function(e){
            self._hideTextColorPicker();
            self._hideFontType();
            self._hideHighlightColorPicker();
            self._hideFontSize();
            jsgtkEvent.stopBubble(e);
    });
    
    jsgtkEvent.addDomListener(this._divColorContainer, "click", function(e){
           self._setFontColor(self._getColorCode(e.target));
           self.setFocus();
    });
    
    jsgtkEvent.addDomListener(this._buttonHighlight, "click", function(e){
        if(!self._isHighlightColorVisible){
            self._hideTextColorPicker();
            self._hideFontType();
            self._hideFontSize();
            self._showHighlightColorPicker();
            jsgtkEvent.stopBubble(e);
        }
        else{
            self._hideHighlightColorPicker();
            jsgtkEvent.stopBubble(e);
        }
        
    });
    
    jsgtkEvent.addDomListener(this._divHighlightColor, "click", function(e){
           self._setBackgroundColor(self._getColorCode(e.target));
           self.setFocus();
    });
    
    jsgtkEvent.addDomListener(this._buttonFontType, "click", function(e){
        if(!self._isFontVisible){
            self._hideTextColorPicker();
            self._hideHighlightColorPicker();
            self._hideFontSize();
            self._showFontType();
            jsgtkEvent.stopBubble(e);
            self.setFocus();
        }
        else{
            self._hideFontType();
            jsgtkEvent.stopBubble(e);
        }
        
    });
    jsgtkEvent.addDomListener(this._divFontTypeContainer, "click", function(e){
           self._setFontType(e.target.style.fontFamily);
           self.setFocus();
    });
    
    jsgtkEvent.addDomListener(this._buttonFontSize, "click", function(e){
        if(!self._isFontSizeVisible){
            self._hideTextColorPicker();
            self._hideHighlightColorPicker();
            self._hideFontType();
            self._showFontSize();
            jsgtkEvent.stopBubble(e);
        }
        else{
            self._hideFontSize();
            jsgtkEvent.stopBubble(e);
        }
        
    });
    
    jsgtkEvent.addDomListener(this._divFontSizeContainer, "click", function(e){
           self._setFontSize(self._getFontSize(e.target));
           self.setFocus();
    });
    
    jsgtkEvent.addDomListener(this._buttonLink, "click", function(e){
       self._linkCommand(e);
    });
    
    jsgtkEvent.addDomListener(this._buttonBulletedList, "click", function(e){
       self._execBulletedButton(self._buttonBulletedList, "insertUnorderedList");
    });
    jsgtkEvent.addDomListener(this._buttonNumberedList, "click", function(e){
       self._execBulletedButton(self._buttonNumberedList, "insertOrderedList");
    });
    jsgtkEvent.addDomListener(this._buttonIndent, "click", function(){
       self._setStyle("indent");
       self.setFocus();
    });
    jsgtkEvent.addDomListener(this._buttonOutdent, "click", function(){
       self._setStyle("outdent");
       self.setFocus();
    });
    jsgtkEvent.addDomListener(this._buttonRemoveStyle, "click", function(){
       self._setStyle("removeFormat");
       self.setFocus();
    });
    
};

/** @private */
gtk.TextEditor.prototype._linkCommand = function (e) {
   var self = this;
   var jsgtkEvent = jsgtk.Event;
   
   var elementName = this._getAncestor(this._getSelectTextObj().anchorNode);
   if(!elementName){
          this._showPopupLink();
          this._cancelButton.connect("clicked", function(){
                self._popup.close();
                jsgtkEvent.stopBubble(e);
          });
          this._okButton.connect("clicked", function(){
                if(self._getSelectedText() != ""){
                    if(self._trim(self._linkEntry.getText()) != ""){
                        self._setStyle("createLink", self._linkEntry.getText());
                        self._buttonLink.className +=" gtk_text_editor_active";
                        self._popup.close();
                        self.setFocus();
                        jsgtkEvent.stopBubble(e);
                    }
                }
                else{
                    if(self._trim(self._linkEntry.getText()) != ""){
                        self._setStyle("insertHTML", "<a href="+ self._linkEntry.getText() + ">"+ self._linkEntry.getText() +"</a>");
                        self._buttonLink.className +=" gtk_text_editor_active";
                        self._popup.close();
                        self.setFocus();
                        jsgtkEvent.stopBubble(e);
                    }
                }
           }); 
                   
    }   
    else{
        this._buttonLink.className =" gtk_text_editor_link";
        this._setStyle("unlink");
    }	
};

/** @private */
gtk.TextEditor.prototype._getSelectTextObj = function(){
    return this._iFrameDomobj.contentWindow.getSelection();
};

/** @private */
gtk.TextEditor.prototype._trim = function(str) { return str.replace(/^\s+|\s+$/, ''); };

/** @private */
gtk.TextEditor.prototype._getAncestor = function(el) {
	while (el.tagName != "BODY") {
		if (el.tagName == "A") {
		    return true;
		}else{
		    el = el.parentNode;
		}
	}
	return false;
};

/** @private */
gtk.TextEditor.prototype._showTextColorPicker = function(){
    this._divColorContainer.style.display = "block";
    this._isTextColorVisible = true;
};

/** @private */
gtk.TextEditor.prototype._hideTextColorPicker = function(){
    this._divColorContainer.style.display = "none";
    this._isTextColorVisible = false;
};

/** @private */
gtk.TextEditor.prototype._showHighlightColorPicker = function(){
    this._divHighlightColor.style.display = "block";
    this._isHighlightColorVisible = true;
};

/** @private */
gtk.TextEditor.prototype._hideHighlightColorPicker = function(){
    this._divHighlightColor.style.display = "none";
    this._isHighlightColorVisible = false;
};

/** @private */
gtk.TextEditor.prototype._showFontType = function(){
    this._divFontTypeContainer.style.display = "block";
    this._isFontVisible = true;
};

/** @private */
gtk.TextEditor.prototype._hideFontType = function(){
    this._divFontTypeContainer.style.display = "none";
    this._isFontVisible = false;
};

/** @private */
gtk.TextEditor.prototype._showFontSize = function(){
    this._divFontSizeContainer.style.display = "block";
    this._isFontSizeVisible = true;
};

/** @private */
gtk.TextEditor.prototype._hideFontSize = function(){
    this._divFontSizeContainer.style.display = "none";
    this._isFontSizeVisible = false;
};

/** @private */
gtk.TextEditor.prototype._execCommand = function(obj){
    var objStyle = obj._styleName;
    var boldState = this._getCommandState(objStyle);
    
    if(boldState === false){
            obj.className += " gtk_text_editor_active";
            this._setStyle(objStyle);
        }
        else{
            obj.className = "gtk_text_editor_"+ objStyle;
            this._setStyle(objStyle);            
        }   
        this.setFocus();
};

/** @private */
gtk.TextEditor.prototype._execBulletedButton = function(buttonObj, stylename){
        this._buttonNumberedList.className = "gtk_text_editor_numberedlist";
        this._buttonBulletedList.className = "gtk_text_editor_bulleted"; 
         
        var bulletListState = this._getCommandState(stylename);
        if(bulletListState === false){
            buttonObj.className += " gtk_text_editor_active";            
            this._setStyle(stylename);
        }  
        else{
            this._setStyle(stylename);
        } 
        this.setFocus();
};

/** @private */
gtk.TextEditor.prototype._execJustify = function(obj){
    this._buttonJustifyLeft._activate = false;
    this._buttonJustifyLeft.className = "gtk_text_editor_justifyleft";
        
    this._buttonJustifyCenter._activate = false;
    this._buttonJustifyCenter.className = "gtk_text_editor_justifycenter";
            
    this._buttonJustifyRight._activate = false;
    this._buttonJustifyRight.className = "gtk_text_editor_justifyright";
    
    this._buttonJustifyFull._activate = false;
    this._buttonJustifyFull.className = "gtk_text_editor_justifyfull"; 
            
    if(!obj._activate){
            obj.className += " gtk_text_editor_active";
            this._setStyle(obj._styleName);
     }
     this.setFocus();
};

/** @private */
gtk.TextEditor.prototype._resetToolBar = function(button, queryState){
    if(queryState == true){
        button.className += " gtk_text_editor_active";
    }
    else if(queryState == false){
         button.className = "gtk_text_editor_"+ button._styleName;
    }
};

/** @private */
gtk.TextEditor.prototype._resetLinkToolBar = function(isCmdSet){
    if(isCmdSet === true)this._buttonLink.className += " gtk_text_editor_active";
    else this._buttonLink.className = "gtk_text_editor_link";
};

/** @private */
gtk.TextEditor.prototype._resetToggleButtonList = function(){
    if(this._getCommandState("insertOrderedList") === true){
           this._buttonNumberedList.className += " gtk_text_editor_active";
           this._buttonBulletedList.className = "gtk_text_editor_bulleted";  
    }else if(this._getCommandState("insertUnorderedList") === true){
            this._buttonBulletedList.className += " gtk_text_editor_active";
            this._buttonNumberedList.className = "gtk_text_editor_numberedlist";                  
    }else{
        this._buttonNumberedList.className = "gtk_text_editor_numberedlist";
        this._buttonBulletedList.className = "gtk_text_editor_bulleted";   
    }
    this.setFocus();
};

/** @private */
gtk.TextEditor.prototype._iFrameInitEvent = function(){
    var self = this;
    this._setEditableMode(true);
    this.setFocus();
    var jsgtkEvent = jsgtk.Event;
                                                         
    jsgtkEvent.addDomListener(this._getIFrameDoc(), "click", function(e){
        self._resetToolbarButton();
        self._hideTextColorPicker();
        self._hideHighlightColorPicker();
        self._hideFontType();
        self._hideFontSize();
        jsgtkEvent.stopBubble(e);
    });
    
    jsgtkEvent.addDomListener(this._getIFrameDoc(), "keydown", function(){
       //self._resetToolbarButton();                   
    });
};

/** @private */
gtk.TextEditor.prototype._toggleJustifyToolbar = function(){
    if(this._getCommandState("justifyleft") === true){
        this._execJustify(this._buttonJustifyLeft); 
        return;
    }
    
    if(this._getCommandState("justifycenter") === true){
        this._execJustify(this._buttonJustifyCenter);
        return;
    }
    
    if(this._getCommandState("justifyright") === true){
            this._execJustify(this._buttonJustifyRight);
            return;
    }
    
    if(this._getCommandState("justifyfull") === true){
        this._execJustify(this._buttonJustifyFull);
        return;
    }
};

/** @private */
gtk.TextEditor.prototype._resetToolbarButton = function(){
    this._resetToolBar(this._buttonBold, this._getCommandState("bold"));
    this._resetToolBar(this._buttonItalic, this._getCommandState("italic"));
    this._resetToolBar(this._buttonUnderline, this._getCommandState("underline"));
    this._resetToolBar(this._buttonStrikethrough, this._getCommandState("strikethrough"));
    this._resetLinkToolBar(this._getAncestor(this._getSelectTextObj().anchorNode));
    this._toggleJustifyToolbar();      
    this._resetToggleButtonList();
};

/** @private */
gtk.TextEditor.prototype._showPopupLink = function(){
       var content = this._createPopupLink();
       var title = "Enter a link or URL in the following field:";
       
       this._popup = new gtk.Window(gtk.WINDOW_TOPLEVEL);
       this._popup.appendChild(content);
	   this._popup.setTitle(title);
	   this._popup.setBoldTitle(true);
	   this._popup.disableMinimizeButton();
	   this._popup.disableMaximizeButton();
	   this._popup.disableResize();
	   this._popup.setPosition(gtk.JUSTIFY_CENTER);
	   this._popup.drawModal();
       this._linkEntry.setFocus();
};

/** @private */
gtk.TextEditor.prototype._createPopupLink = function(){
   var VBox = new gtk.VBoxFactory(false, 10);
   var table = new gtk.TableFactory(2, 2, false, false, 30);

       var linkLabel = new gtk.Label("Link to :");
       this._linkEntry = new gtk.Entry();
       this._linkEntry.resizeEntryByFont(16);
       this._linkEntry.resizeHeightComposite(28);
       this._linkEntry.setWidthChars(36);
       this._linkEntry.setText("http://");

   var hboxFooter = new gtk.HBoxFactory(false,0);
       this._okButton = new gtk.Button("Ok");
       this._okButton.setSizeRequest(82, 22);
       this._cancelButton = new gtk.Button("Cancel");
       this._cancelButton.setSizeRequest(82, 22);
       hboxFooter.appendChild(this._okButton,{"expand": true, "fill": false, "padding": 0});
       hboxFooter.appendChild(this._cancelButton,{"expand": true, "fill": false, "padding": 10});
       
       
    table.attach(linkLabel, 0, 1, 0, 1, {align: gtk.JUSTIFY_RIGHT, fill: true}, {align: gtk.JUSTIFY_CENTER, fill: true}, 30, 24);
    table.attach(this._linkEntry, 1, 2, 0, 1, {align: gtk.JUSTIFY_LEFT, fill: false}, {align: gtk.JUSTIFY_CENTER, fill: true}, 10, 20);
    table.attach(hboxFooter, 1, 2, 1, 2, {align: gtk.JUSTIFY_RIGHT, fill: false}, {align: gtk.JUSTIFY_CENTER, fill: true}, 1, 50);
    table.resizeHeightComposite(150);
    
    VBox.appendChild(table, {"expand": true, "fill": true, "padding": 0});
    VBox.resetMinWidth(400);
    VBox.resetMinHeight(135);
    
   	return VBox;
};

/**
 *	Set enabled to TextEditor
 */
gtk.TextEditor.prototype.enable = function(){
    this._setEditableMode(true);
    this._disabledModal.className = "";
};

/**
 *	Set disabled to TextEditor
 */
gtk.TextEditor.prototype.disable = function(){
	this._setEditableMode(false);
	if(this._disabledModal === null){
		this._disabledModal = jsgtk.Dom.create({tag: "div", className: "gtk_text_editor_disabled"});
		this._domObj.appendChild(this._disabledModal);
	}else this._disabledModal.className = "gtk_text_editor_disabled";
};

/**
 *	Get minimum width of TextEditor
 *	@param{Integer}, the minimum width of TextEditor
 */
gtk.TextEditor.prototype.resetMinWidth = function(width){
	this._width = this._minWidth = width > this._minWidth ? width : this._minWidth;
	this._resizeWidth(this._minWidth);
};

/**
 *	Set minimum height of TextEditor
 *	@param{Integer}, the minimum height of TextEditor
 */
gtk.TextEditor.prototype.resetMinHeight = function(height){
	this._height = this._minHeight = height > this._minHeight ? height : this._minHeight;
	this._resizeHeight(this._minHeight);
};

/**
 *	Get minimum width of TextEditor
 *	@return{Integer}, the minimum width of TextEditor
 */
gtk.TextEditor.prototype.getMinWidthComposite = function(){
	return this._minWidth;
};

/**
 *	Get minimum height of TextEditor
 *	@return{Integer}, the minimum height of TextEditor
 */
gtk.TextEditor.prototype.getMinHeightComposite = function(){
	return this._minHeight;
};
/** @private */
gtk.TextEditor.prototype.resize = function(width, height){
    this._resizeWidth(width);
    this._resizeHeight(height);
};

/** @private */
gtk.TextEditor.prototype._resizeWidth = function(width){
	this._domObj.style.width = width + "px";
	this._iFrameDomobj.style.width = this._width - 2 + "px";
	this._width = width;
};
/** @private */
gtk.TextEditor.prototype._resizeHeight = function(height){
   this._domObj.style.height = height + "px";
   this._iFrameDomobj.style.height = height - 26 + "px";
	this._height = height;
};

/**
 *	Resize width of TextEditor
 *	@param{Integer}, width of TextEditor
 */
gtk.TextEditor.prototype.resizeWidthComposite = function(width){
	this._width = width > this._minWidth ? width : this._minWidth;
	this._resizeWidth(this._width);
};
/**
 *	Resize height of TextEditor
 *	@param{Integer}, height of TextEditor
 */
gtk.TextEditor.prototype.resizeHeightComposite = function(height){
	this._height = height > this._minHeight ? height : this._minHeight;
	this._resizeHeight(this._height);
};
